(declare-fun R () (_ BitVec 1))
(declare-fun IC () (_ BitVec 8))
(declare-fun ID () (_ BitVec 32))
(declare-fun virus () (_ BitVec 7))
(declare-fun one () (_ BitVec 1))
(declare-fun zero () (_ BitVec 1))
(declare-fun array0 () (Array (_ BitVec 1) (_ BitVec 32)))
(declare-fun array1 () (Array (_ BitVec 1) (_ BitVec 32)))

(define-fun mux2to1 ( (s0(_ BitVec 8)) (s1(_ BitVec 8)) (s(_ BitVec 1))) (_ BitVec 8)
	(ite (= s (_ bv0 1)) s0 s1)
)

(define-fun module1_syndrome ((r(_ BitVec 1)) (ic(_ BitVec 8)) (id(_ BitVec 32))) (_ BitVec 8)
	(let
		(
			(id31 ((_ extract 31 31) id))
			(id30 ((_ extract 30 30) id))
			(id29 ((_ extract 29 29) id))
			(id28 ((_ extract 28 28) id))			
			(id27 ((_ extract 27 27) id))
			(id26 ((_ extract 26 26) id))
			(id25 ((_ extract 25 25) id))
			(id24 ((_ extract 24 24) id))
			(id23 ((_ extract 23 23) id))
			(id22 ((_ extract 22 22) id))
			(id21 ((_ extract 21 21) id))
			(id20 ((_ extract 20 20) id))
			(id19 ((_ extract 19 19) id))
			(id18 ((_ extract 18 18) id))			
			(id17 ((_ extract 17 17) id))
			(id16 ((_ extract 16 16) id))
			(id15 ((_ extract 15 15) id))
			(id14 ((_ extract 14 14) id))
			(id13 ((_ extract 13 13) id))
			(id12 ((_ extract 12 12) id))
			(id11 ((_ extract 11 11) id))
			(id10 ((_ extract 10 10) id))
			(id9 ((_ extract 9 9) id))
			(id8 ((_ extract 8 8) id))			
			(id7 ((_ extract 7 7) id))
			(id6 ((_ extract 6 6) id))
			(id5 ((_ extract 5 5) id))
			(id4 ((_ extract 4 4) id))
			(id3 ((_ extract 3 3) id))
			(id2 ((_ extract 2 2) id))
			(id1 ((_ extract 1 1) id))
			(id0 ((_ extract 0 0) id))
			
			(ic7 ((_ extract 7 7) ic))
			(ic6 ((_ extract 6 6) ic))
			(ic5 ((_ extract 5 5) ic))
			(ic4 ((_ extract 4 4) ic))
			(ic3 ((_ extract 3 3) ic))
			(ic2 ((_ extract 2 2) ic))
			(ic1 ((_ extract 1 1) ic))
			(ic0 ((_ extract 0 0) ic))
		)
	(let
		(
			(s0 (bvxor id0 id4 id8 id12 id16 id17 id18 id19 id20 id21 id22 id23 (bvand r ic0)))
			(s1 (bvxor id1 id5 id9 id13 id24 id25 id26 id27 id28 id29 id30 id31 (bvand r ic1)))
			(s2 (bvxor id2 id6 id10 id14 id16 id17 id18 id19 id24 id25 id26 id27 (bvand r ic2)))
			(s3 (bvxor id3 id7 id11 id15 id20 id21 id22 id23 id28 id29 id30 id31(bvand r ic3)))
			(s4 (bvxor id16 id20 id24 id28 id0 id1 id2 id3 id4 id5 id6 id7 (bvand r ic4)))
			(s5 (bvxor id17 id21 id25 id29 id8 id9 id10 id11 id12 id13 id14 id15 (bvand r ic5)))
			(s6 (bvxor id18 id22 id26 id30 id0 id1 id2 id3 id8 id9 id10 id11 (bvand r ic6)))
			(s7 (bvxor id19 id23 id27 id31 id4 id5 id6 id7 id12 id13 id14 id15 (bvand r ic7)))
		)
	(let
		(
			(s (concat s7 s6 s5 s4 s3 s2 s1 s0))
		)
	)))
)

(define-fun module2_correction ((s(_ BitVec 32)) (id(_ BitVec 32))) (_ BitVec 32)
	(let
		(
			(id31 ((_ extract 31 31) id))
			(id30 ((_ extract 30 30) id))
			(id29 ((_ extract 29 29) id))
			(id28 ((_ extract 28 28) id))			
			(id27 ((_ extract 27 27) id))
			(id26 ((_ extract 26 26) id))
			(id25 ((_ extract 25 25) id))
			(id24 ((_ extract 24 24) id))
			(id23 ((_ extract 23 23) id))
			(id22 ((_ extract 22 22) id))
			(id21 ((_ extract 21 21) id))
			(id20 ((_ extract 20 20) id))
			(id19 ((_ extract 19 19) id))
			(id18 ((_ extract 18 18) id))			
			(id17 ((_ extract 17 17) id))
			(id16 ((_ extract 16 16) id))
			(id15 ((_ extract 15 15) id))
			(id14 ((_ extract 14 14) id))
			(id13 ((_ extract 13 13) id))
			(id12 ((_ extract 12 12) id))
			(id11 ((_ extract 11 11) id))
			(id10 ((_ extract 10 10) id))
			(id9 ((_ extract 9 9) id))
			(id8 ((_ extract 8 8) id))			
			(id7 ((_ extract 7 7) id))
			(id6 ((_ extract 6 6) id))
			(id5 ((_ extract 5 5) id))
			(id4 ((_ extract 4 4) id))
			(id3 ((_ extract 3 3) id))
			(id2 ((_ extract 2 2) id))
			(id1 ((_ extract 1 1) id))
			(id0 ((_ extract 0 0) id))
			
			(s7 ((_ extract 7 7) s))
			(s6 ((_ extract 6 6) s))
			(s5 ((_ extract 5 5) s))
			(s4 ((_ extract 4 4) s))
			(s3 ((_ extract 3 3) s))
			(s2 ((_ extract 2 2) s))
			(s1 ((_ extract 1 1) s))
			(s0 ((_ extract 0 0) s))
		)
	(let
		(
			(od0 (bvxor (bvand s0 (bvnot s1) (bvnot s2) (bvnot s3) s4 (bvnot s5) s6 (bvnot s7)) id0))
			(od1 (bvxor (bvand s1 (bvnot s0) (bvnot s2) (bvnot s3) s4 (bvnot s5) s6 (bvnot s7)) id1))
			(od2 (bvxor (bvand s2 (bvnot s0) (bvnot s1) (bvnot s3) s4 (bvnot s5) s6 (bvnot s7)) id2))
			(od3 (bvxor (bvand s3 (bvnot s0) (bvnot s1) (bvnot s2) s4 (bvnot s5) s6 (bvnot s7)) id3))
			(od4 (bvxor (bvand s0 (bvnot s1) (bvnot s2) (bvnot s3) s4 (bvnot s5) s7 (bvnot s6)) id4))
			(od5 (bvxor (bvand s1 (bvnot s0) (bvnot s2) (bvnot s3) s4 (bvnot s5) s7 (bvnot s6)) id5))
			(od6 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s3) (bvnot s5) (bvnot s6) s2 s4 s7) id6))
			(od7 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s2) (bvnot s5) (bvnot s6) s3 s4 s7) id7))
			(od8 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s3) (bvnot s4) (bvnot s7) s0 s5 s6) id8))
			(od9 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s3) (bvnot s4) (bvnot s7) s1 s5 s6) id9))
			(od10 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s3) (bvnot s4) (bvnot s7) s2 s5 s6) id10))
			(od11 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s2) (bvnot s4) (bvnot s7) s3 s5 s6) id11))
			(od12 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s3) (bvnot s4) (bvnot s6) s0 s5 s7) id12))
			(od13 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s3) (bvnot s4) (bvnot s6) s1 s5 s7) id13))
			(od14 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s3) (bvnot s4) (bvnot s6) s2 s5 s7) id14))
			(od15 (bvxor (bvand (bvnot s0) (bvnot s1) (bvnot s2) (bvnot s4) (bvnot s6) s3 s5 s7) id15))
			(od16 (bvxor (bvand (bvnot s1) (bvnot s3) (bvnot s5) (bvnot s6) (bvnot s7) s0 s2 s4) id16))
			(od17 (bvxor (bvand (bvnot s1) (bvnot s3) (bvnot s4) (bvnot s6) (bvnot s7) s0 s2 s5) id17))
			(od18 (bvxor (bvand (bvnot s1) (bvnot s3) (bvnot s4) (bvnot s5) (bvnot s7) s0 s2 s6) id18))
			(od19 (bvxor (bvand (bvnot s1) (bvnot s3) (bvnot s4) (bvnot s5) (bvnot s6) s0 s2 s7) id19))
			(od20 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s5) (bvnot s6) (bvnot s7) s0 s3 s4) id20))
			(od21 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s4) (bvnot s6) (bvnot s7) s0 s3 s5) id21))
			(od22 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s4) (bvnot s5) (bvnot s7) s0 s3 s6) id22))
			(od23 (bvxor (bvand (bvnot s1) (bvnot s2) (bvnot s4) (bvnot s5) (bvnot s6) s0 s3 s7) id23))
			(od24 (bvxor (bvand (bvnot s0) (bvnot s3) (bvnot s5) (bvnot s6) (bvnot s7) s1 s2 s4) id24))
			(od25 (bvxor (bvand (bvnot s0) (bvnot s3) (bvnot s4) (bvnot s6) (bvnot s7) s1 s2 s5) id25))
			(od26 (bvxor (bvand (bvnot s0) (bvnot s3) (bvnot s4) (bvnot s5) (bvnot s7) s1 s2 s6) id26))
			(od27 (bvxor (bvand (bvnot s0) (bvnot s3) (bvnot s4) (bvnot s5) (bvnot s6) s1 s2 s7) id27))
			(od28 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s5) (bvnot s6) (bvnot s7) s1 s3 s4) id28))
			(od29 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s4) (bvnot s6) (bvnot s7) s1 s3 s5) id29))
			(od30 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s4) (bvnot s5) (bvnot s7) s1 s3 s6) id30))
			(od31 (bvxor (bvand (bvnot s0) (bvnot s2) (bvnot s4) (bvnot s5) (bvnot s6) s1 s3 s7) id31))
		)
	(let
		(
			(od (concat od31 od30 od29 od28 od27 od26 od25 od24 od23 od22 od21 od20 od19 od18 od17 od16 od15 od14 od13 od12 od11 od10 od9 od8 od7 od6 od5 od4 od3 od2 od1 od0))
		)
	)))
)




(assert
	(not
		(let
			(
				(v0 ((_ extract 0 0) virus))
				(v1 ((_ extract 1 1) virus))
				(v2 ((_ extract 2 2) virus))
				(v3 ((_ extract 3 3) virus))
				(v4 ((_ extract 4 4) virus))
				(v5 ((_ extract 5 5) virus))
				(v6 ((_ extract 6 6) virus))
				
				(Rprime (bvnot R))
			)
		(let
			(
				(trojan0 (concat zero v6 v5 v4 v3 v2 v1 v0))
				(trojan1 (concat one v6 v5 v4 v3 v2 v1 v0))
			)
		(let
			(
				(temp10 (mux2to1 trojan0 IC Rprime))
				(temp20 (mux2to1 IC trojan0 Rprime))
				(temp11 (mux2to1 trojan1 IC Rprime))
				(temp21 (mux2to1 IC trojan1 Rprime))
			)
		(let
			(
				(ic0 (mux2to1 temp10 temp20 R))
				(ic1 (mux2to1 temp11 temp21 R))
			)
		(let
			(
				(syndrome0 (module1_syndrome R ic0 ID))
				(syndrome1 (module1_syndrome R ic1 ID))
			)
		(let
			(
				(synd0 (concat (_ bv0 24) syndrome0))
				(synd1 (concat (_ bv0 24) syndrome1))
			)
		(let
			(
				(array0 (store array0 (_ bv0 1) synd0))
				(array1 (store array1 (_ bv0 1) synd1))
			)
		(let
			(
				(out0 (module2_correction synd0 ID))
				(out1 (module2_correction synd1 ID))
			)
		(let
			(
				(array0 (store array0 (_ bv1 1) out0))
				(array1 (store array1 (_ bv1 1) out1))
			)
		(=>
			(and (= zero (_ bv0 1)) (= one (_ bv1 1)))
			(= array0 array1)
		))))))))))
	)
)

(check-sat)
(get-model)