(declare-fun InDataBus () (_ BitVec 16))
(declare-fun InCheckBits_T () (_ BitVec 6))
(declare-fun InExtSynBits () (_ BitVec 4))
(declare-fun ContE () (_ BitVec 1))
(declare-fun ContB () (_ BitVec 1))
(declare-fun ContF () (_ BitVec 1))
(declare-fun ContG () (_ BitVec 1))
(declare-fun ContH () (_ BitVec 1))
(declare-fun ContK_T () (_ BitVec 1))
(declare-fun ContL_T () (_ BitVec 1))
(declare-fun virus () (_ BitVec 7))
(declare-fun zero () (_ BitVec 1))
(declare-fun one () (_ BitVec 1))
(declare-fun array0 () (Array (_ BitVec 2) (_ BitVec 82)))
(declare-fun array1 () (Array (_ BitVec 2) (_ BitVec 82)))

(define-fun mux2to1 ( (s0(_ BitVec 8)) (s1(_ BitVec 8)) (s(_ BitVec 1))) (_ BitVec 8)
	(ite (= s (_ bv0 1)) s0 s1)
)

(define-fun SyndromeGenerator ((InDataBus(_ BitVec 16)) (InCheckBits(_ BitVec 6)) (ContB(_ BitVec 1)) (ContG(_ BitVec 1)) (ContH(_ BitVec 1)) ) (_ BitVec 8)
; output format ------------ synbits indbparHi indbparLo
	(let
		(
			(InDataBus0 ((_ extract 0 0) InDataBus))
			(InDataBus1 ((_ extract 1 1) InDataBus))
			(InDataBus2 ((_ extract 2 2) InDataBus))
			(InDataBus3 ((_ extract 3 3) InDataBus))
			(InDataBus4 ((_ extract 4 4) InDataBus))
			(InDataBus5 ((_ extract 5 5) InDataBus))
			(InDataBus6 ((_ extract 6 6) InDataBus))
			(InDataBus7 ((_ extract 7 7) InDataBus))
			(InDataBus8 ((_ extract 8 8) InDataBus))
			(InDataBus9 ((_ extract 9 9) InDataBus))
			(InDataBus10 ((_ extract 10 10) InDataBus))
			(InDataBus11 ((_ extract 11 11) InDataBus))
			(InDataBus12 ((_ extract 12 12) InDataBus))
			(InDataBus13 ((_ extract 13 13) InDataBus))
			(InDataBus14 ((_ extract 14 14) InDataBus))
			(InDataBus15 ((_ extract 15 15) InDataBus))
			
			(InCheckBits0 ((_ extract 0 0) InCheckBits))
			(InCheckBits1 ((_ extract 1 1) InCheckBits))
			(InCheckBits2 ((_ extract 2 2) InCheckBits))
			(InCheckBits3 ((_ extract 3 3) InCheckBits))
			(InCheckBits4 ((_ extract 4 4) InCheckBits))
			(InCheckBits5 ((_ extract 5 5) InCheckBits))
		)
	(let
		(
			(Not_ContB (bvnot ContB))
			(Not_ContH (bvnot ContH))
		)
	(let
		(
			(temp0 (bvand InCheckBits0 ContG Not_ContB))
			(temp1 (bvand InCheckBits1 Not_ContH Not_ContB))
			(temp2 (bvand InCheckBits2 Not_ContH Not_ContB))
			(temp3 (bvand InCheckBits3 Not_ContB))
			(temp4 (bvand InCheckBits4 ContG Not_ContB))
			(temp5 (bvand InCheckBits5 Not_ContB))
		)
	(let
		(
			(NotInDataBus0 (bvnot InDataBus0))
			(NotInDataBus1 (bvnot InDataBus1))
			(NotInDataBus2 (bvnot InDataBus2))
			(NotInDataBus3 (bvnot InDataBus3))
			(NotInDataBus4 (bvnot InDataBus4))
			(NotInDataBus5 (bvnot InDataBus5))
			(NotInDataBus6 (bvnot InDataBus6))
			(NotInDataBus7 (bvnot InDataBus7))
			(NotInDataBus8 (bvnot InDataBus8))
			(NotInDataBus9 (bvnot InDataBus9))
			(NotInDataBus10 (bvnot InDataBus10))
			(NotInDataBus11 (bvnot InDataBus11))
			(NotInDataBus12 (bvnot InDataBus12))
			(NotInDataBus13 (bvnot InDataBus13))
			(NotInDataBus14 (bvnot InDataBus14))
			(NotInDataBus15 (bvnot InDataBus15))
		)
	(let((line46 (bvxor NotInDataBus7 NotInDataBus5)))
	(let((line47 (bvxor line46 NotInDataBus2)))
	(let((line48 (bvxor NotInDataBus14 NotInDataBus9)))
	(let((line49 (bvxor line48 NotInDataBus11)))
	(let((line50 (bvxor line47 line49)))
	(let((SynBits0 (bvxor line50 temp0)))
	(let((line38 (bvxor NotInDataBus8 NotInDataBus13)))
	(let((line39 (bvxor line38 NotInDataBus15)))
	(let((line40 (bvxor NotInDataBus14 temp1)))
	(let((line41 (bvxor line40 NotInDataBus10)))
	(let((line42 (bvxor line39 line41)))
	(let((line43 (bvxor NotInDataBus7 NotInDataBus4)))
	(let((line44 (bvxor line43 NotInDataBus1)))
	(let((SynBits1 (bvxor line42 line44)))
	(let((line24 (bvxor NotInDataBus0 temp2)))
	(let((line25 (bvxor NotInDataBus12 NotInDataBus11)))
	(let((line26 (bvxor line25 NotInDataBus10)))
	(let((line27 (bvnot line26)))
	(let((line28 (bvxor NotInDataBus15 NotInDataBus14)))
	(let((line29 (bvxor line28 NotInDataBus9)))
	(let((line30 (bvxor line27 line29)))
	(let((line31 (bvxor NotInDataBus6 NotInDataBus5)))
	(let((line32 (bvxor line31 NotInDataBus4)))
	(let((line33 (bvnot line32)))
	(let((line34 (bvxor line30 line33)))
	(let((line35 (bvnot line34)))
	(let((line36 (bvnot line24)))
	(let((SynBits2 (bvxor line36 line35)))
	(let((line76 (bvxor NotInDataBus3 NotInDataBus13)))
	(let((line77 (bvxor line76 temp3)))
	(let((line78 (bvxor NotInDataBus2 NotInDataBus1)))
	(let((line79 (bvxor line78 NotInDataBus0)))
	(let((line80 (bvxor NotInDataBus15 NotInDataBus14)))
	(let((line81 (bvxor line80 NotInDataBus9)))
	(let((line82 (bvnot line81)))
	(let((line83 (bvxor line79 line82)))
	(let((line84 (bvxor line83 line27)))
	(let((line85 (bvnot line84)))
	(let((SynBits3 (bvxor line77 line85)))
	(let((line52 (bvxor NotInDataBus8 NotInDataBus13)))
	(let((line53 (bvxor line52 NotInDataBus15)))
	(let((line54 (bvnot line53)))
	(let((line55 (bvxor NotInDataBus9 NotInDataBus6)))
	(let((line56 (bvxor line55 NotInDataBus3)))
	(let((line57 (bvnot line56)))
	(let((line58 (bvxor line54 line57)))
	(let((line59 (bvxor temp4 NotInDataBus12)))
	(let((line60 (bvnot line59)))
	(let((SynBits4 (bvxor line58 line60)))
	(let((line62 (bvxor line29 NotInDataBus8)))
	(let((line63 (bvxor line62 temp5)))
	(let((line64 (bvnot line63)))
	(let((line65 (bvxor NotInDataBus2 NotInDataBus1)))
	(let((line66 (bvxor line65 NotInDataBus0)))
	(let((line67 (bvnot line66)))
	(let((line68 (bvxor NotInDataBus6 NotInDataBus5)))
	(let((line69 (bvxor line68 NotInDataBus4)))
	(let((line70 (bvxor line67 line69)))
	(let((line71 (bvxor NotInDataBus7 NotInDataBus3)))
	(let((line72 (bvnot line71)))
	(let((line73 (bvxor line70 line72)))
	(let((line74 (bvxor line64 line73)))
	(let((SynBits5 (bvnot line74)))
	(let((line87 (bvxor line67 line69)))
	(let((InDBParityLo (bvxor line87 line72)))
	(let((line89 (bvxor NotInDataBus12 NotInDataBus11)))
	(let((line90 (bvxor line89 NotInDataBus10)))
	(let((line91 (bvxor line82 line90)))
	(let((line92 (bvxor NotInDataBus13 NotInDataBus8)))
	(let((line93 (bvnot line92)))
	(let((InDBParityHi (bvxor line91 line93)))
	(let
	(
		(out (concat SynBits5 SynBits4 SynBits3 SynBits2 SynBits1 SynBits0 InDBParityHi InDBParityLo))
	)
	)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
	)))))
)

;------output format -------- NewSynBits Not_NewSynBits AllExtSynBits ContIntM ContIntP

(define-fun ModifySyndrome ((SynBits(_ BitVec 6)) (InExtSynBits(_ BitVec 4)) (InCheckBits(_ BitVec 6)) (ContE(_ BitVec 1)) (ContG(_ BitVec 1)) (ContH(_ BitVec 1)) ) (_ BitVec 20)
	(let
		(
		(SynBits0 ((_ extract 0 0) SynBits))
		(SynBits1 ((_ extract 1 1) SynBits))
		(SynBits2 ((_ extract 2 2) SynBits))
		(SynBits3 ((_ extract 3 3) SynBits))
		(SynBits4 ((_ extract 4 4) SynBits))
		(SynBits5 ((_ extract 5 5) SynBits))
		
		(AllExtSynBits0 ((_ extract 0 0) InExtSynBits))
		(AllExtSynBits1 ((_ extract 1 1) InExtSynBits))
		(AllExtSynBits2 ((_ extract 2 2) InExtSynBits))
		(AllExtSynBits3 ((_ extract 3 3) InExtSynBits))
		
		(InCheckBits0 ((_ extract 0 0) InCheckBits))
		(InCheckBits1 ((_ extract 1 1) InCheckBits))
		(InCheckBits2 ((_ extract 2 2) InCheckBits))
		(InCheckBits3 ((_ extract 3 3) InCheckBits))
		(InCheckBits4 ((_ extract 4 4) InCheckBits))
		(InCheckBits5 ((_ extract 5 5) InCheckBits))
		)
	(let
	(
		(Not_ContE (bvnot ContE))
	)
	(let
	(
		(line7 (bvnand ContG Not_ContE))
		
		(Not_ContH (bvnot ContH))
		
		(temp0 (bvand SynBits0 Not_ContE))
		(temp1 (bvand SynBits1 Not_ContE))
		(temp2 (bvand SynBits2 Not_ContE))
		(temp3 (bvand SynBits3 Not_ContE))
		(temp4 (bvand SynBits4 Not_ContE))
		(temp5 (bvand SynBits5 Not_ContE))
	)
	(let
	(
		(AllExtSynBits4 (bvand InCheckBits0 line7))
		
		(line10 (bvnand Not_ContE Not_ContH))
	)
	(let
	(
		(AllExtSynBits5 (bvand line10 InCheckBits2))
	)
	(let
	(
		(ContIntM (bvnand InCheckBits1 line10))
		(ContIntP (bvnand line7 InCheckBits4))
	)
	(let
	(
		(NewSynBits0 (bvxor temp0 AllExtSynBits0))
		(NewSynBits1 (bvxor temp1 AllExtSynBits1))
		(NewSynBits2 (bvxor temp2 AllExtSynBits2))
		(NewSynBits3 (bvxor temp3 AllExtSynBits3))
		(NewSynBits4 (bvxor temp4 AllExtSynBits4))
		(NewSynBits5 (bvxor temp5 AllExtSynBits5))
	)
	(let
	(
		(Not_NewSynBits0 (bvnot NewSynBits0))
		(Not_NewSynBits1 (bvnot NewSynBits1))
		(Not_NewSynBits2 (bvnot NewSynBits2))
		(Not_NewSynBits3 (bvnot NewSynBits3))
		(Not_NewSynBits4 (bvnot NewSynBits4))
		(Not_NewSynBits5 (bvnot NewSynBits5))
	)
	(let
	(
		(out (concat NewSynBits5 NewSynBits4 NewSynBits3 NewSynBits2 NewSynBits1 NewSynBits0 Not_NewSynBits5 Not_NewSynBits4 Not_NewSynBits3
		Not_NewSynBits2 Not_NewSynBits1 Not_NewSynBits0 AllExtSynBits5 AllExtSynBits4 AllExtSynBits3 AllExtSynBits2 AllExtSynBits1 AllExtSynBits0
		ContIntM ContIntP))
	)
	)))))))))
)

;-----------------------------
(define-fun SyndromeDecode ((NewSynBits(_ BitVec 6)) (Not_NewSynBits(_ BitVec 6)) (ContIntM(_ BitVec 1)) (ContIntP(_ BitVec 1)) (ContE(_ BitVec 1)) (ContB(_ BitVec 1)) (ContF(_ BitVec 1)) (ContG(_ BitVec 1)) (ContH(_ BitVec 1)) (ContK(_ BitVec 1)) (ContL(_ BitVec 1)) ) (_ BitVec 31)
;-------output format DecodedSyn ProductSyn CorrectionFlag CorrectionFlagHi CorrectionFlagLo
	(let
	(
		(NewSynBits0 ((_ extract 0 0) NewSynBits))
		(NewSynBits1 ((_ extract 1 1) NewSynBits))
		(NewSynBits2 ((_ extract 2 2) NewSynBits))
		(NewSynBits3 ((_ extract 3 3) NewSynBits))
		(NewSynBits4 ((_ extract 4 4) NewSynBits))
		(NewSynBits5 ((_ extract 5 5) NewSynBits))
		
		(Not_NewSynBits0 ((_ extract 0 0) Not_NewSynBits))
		(Not_NewSynBits1 ((_ extract 1 1) Not_NewSynBits))
		(Not_NewSynBits2 ((_ extract 2 2) Not_NewSynBits))
		(Not_NewSynBits3 ((_ extract 3 3) Not_NewSynBits))
		(Not_NewSynBits4 ((_ extract 4 4) Not_NewSynBits))
		(Not_NewSynBits5 ((_ extract 5 5) Not_NewSynBits))
	)
	(let
	(
		(Not_ContK (bvnot ContK))
		(Not_ContL (bvnot ContL))
		(Not_ContB (bvnot ContB))
		(NotGH (bvnand ContG ContH))
	)
	(let
	(
		(line4 (bvnot (bvand Not_ContK ContE ContB NotGH)))
	)
	(let
	(
		(line5 (bvnot (bvand ContF ContB NotGH)))
	)
	(let
	(
		(ContIntLo (bvnand line4 line5))
		(line7 (bvnot (bvand Not_ContL ContE ContB NotGH)))
	)
	(let
	(
		(ContIntHi (bvnand line7 line5))
	)
	(let((ProductSyn0 (bvand ContIntM NewSynBits5)))
	(let((ProductSyn1 (bvand Not_NewSynBits0 Not_NewSynBits1)))
	(let((ProductSyn2 (bvand Not_NewSynBits4 Not_NewSynBits2)))
	(let((ProductSyn3 (bvand Not_NewSynBits0 NewSynBits1)))
	(let((ProductSyn4 (bvand NewSynBits0 Not_NewSynBits1)))
	(let((ProductSyn5 (bvand NewSynBits4 Not_NewSynBits2)))
	(let((ProductSyn6 (bvand ContIntP Not_NewSynBits3)))
	(let((ProductSyn7 (bvand NewSynBits4 NewSynBits2)))
	(let((ProductSyn8 (bvand ContIntM Not_NewSynBits5)))
	(let((ProductSyn9 (bvand Not_NewSynBits4 NewSynBits2)))
	(let((ProductSyn10 (bvand ContIntP NewSynBits3)))
	(let((ProductSyn11 (bvand NewSynBits0 NewSynBits1)))
	(let((DecodedSyn0 (bvand ProductSyn0 ProductSyn10 ProductSyn9 ProductSyn1 ContIntLo)))
	(let((DecodedSyn1 (bvand ProductSyn0 ProductSyn10 ProductSyn2 ProductSyn3 ContIntLo)))
	(let((DecodedSyn2 (bvand ProductSyn0 ProductSyn10 ProductSyn2 ProductSyn4 ContIntLo)))
	(let((DecodedSyn3 (bvand ProductSyn0 ProductSyn10 ProductSyn5 ProductSyn1 ContIntLo)))
	(let((DecodedSyn4 (bvand ProductSyn0 ProductSyn6 ProductSyn9 ProductSyn3 ContIntLo)))
	(let((DecodedSyn5 (bvand ProductSyn0 ProductSyn6 ProductSyn9 ProductSyn4 ContIntLo)))
	(let((DecodedSyn6 (bvand ProductSyn0 ProductSyn6 ProductSyn7 ProductSyn1 ContIntLo)))
	(let((DecodedSyn7 (bvand ProductSyn0 ProductSyn6 ProductSyn2 ProductSyn11 ContIntLo)))
	(let((DecodedSyn8 (bvand ProductSyn0 ProductSyn6 ProductSyn5 ProductSyn3 ContIntHi)))
	(let((DecodedSyn9 (bvand ProductSyn0 ProductSyn10 ProductSyn7 ProductSyn4 ContIntHi)))
	(let((DecodedSyn10 (bvand ProductSyn8 ProductSyn10 ProductSyn9 ProductSyn3 ContIntHi)))
	(let((DecodedSyn11 (bvand ProductSyn8 ProductSyn10 ProductSyn9 ProductSyn4 ContIntHi)))
	(let((DecodedSyn12 (bvand ProductSyn8 ProductSyn10 ProductSyn7 ProductSyn1 ContIntHi)))
	(let((DecodedSyn13 (bvand ProductSyn8 ProductSyn10 ProductSyn5 ProductSyn3 ContIntHi)))
	(let((DecodedSyn14 (bvand ProductSyn0 ProductSyn10 ProductSyn9 ProductSyn11 ContIntHi)))
	(let((DecodedSyn15 (bvand ProductSyn0 ProductSyn10 ProductSyn7 ProductSyn3 ContIntHi)))
	(let
	(
		(CorrectionFlagLo (bvor DecodedSyn0 DecodedSyn1 DecodedSyn2 DecodedSyn3 DecodedSyn4 DecodedSyn5 DecodedSyn6 DecodedSyn7))
	)
	(let
	(
		(CorrectionFlagHi (bvor DecodedSyn8 DecodedSyn9 DecodedSyn10 DecodedSyn11 DecodedSyn12 DecodedSyn13 DecodedSyn14 DecodedSyn15))
	)
	(let
	(
		(CorrectionFlag (bvor CorrectionFlagHi CorrectionFlagLo))
	)
	(let
	(
		(out (concat DecodedSyn15 DecodedSyn14 DecodedSyn13 DecodedSyn12 DecodedSyn11 DecodedSyn10 DecodedSyn9 DecodedSyn8 DecodedSyn7
		DecodedSyn6 DecodedSyn5 DecodedSyn4 DecodedSyn3 DecodedSyn2 DecodedSyn1 DecodedSyn0 ProductSyn11 ProductSyn10 ProductSyn9 
		ProductSyn8 ProductSyn7 ProductSyn6 ProductSyn5 ProductSyn4 ProductSyn3 ProductSyn2 ProductSyn1 ProductSyn0
		CorrectionFlag CorrectionFlagHi CorrectionFlagLo))
	)
	))))))))))))))))))))))))))))))))))))))
)

;----------------------------------------------------------
(define-fun DataBusCorrect ((InDataBus(_ BitVec 16)) (DecodedSyn(_ BitVec 16))) (_ BitVec 16)
	(let
	(
		(InDataBus0 ((_ extract 0 0) InDataBus))
		(InDataBus1 ((_ extract 1 1) InDataBus))
		(InDataBus2 ((_ extract 2 2) InDataBus))
		(InDataBus3 ((_ extract 3 3) InDataBus))
		(InDataBus4 ((_ extract 4 4) InDataBus))
		(InDataBus5 ((_ extract 5 5) InDataBus))
		(InDataBus6 ((_ extract 6 6) InDataBus))
		(InDataBus7 ((_ extract 7 7) InDataBus))
		(InDataBus8 ((_ extract 8 8) InDataBus))
		(InDataBus9 ((_ extract 9 9) InDataBus))
		(InDataBus10 ((_ extract 10 10) InDataBus))
		(InDataBus11 ((_ extract 11 11) InDataBus))
		(InDataBus12 ((_ extract 12 12) InDataBus))
		(InDataBus13 ((_ extract 13 13) InDataBus))
		(InDataBus14 ((_ extract 14 14) InDataBus))
		(InDataBus15 ((_ extract 15 15) InDataBus))
		
		(DecodedSyn0 ((_ extract 0 0) DecodedSyn))
		(DecodedSyn1 ((_ extract 1 1) DecodedSyn))
		(DecodedSyn2 ((_ extract 2 2) DecodedSyn))
		(DecodedSyn3 ((_ extract 3 3) DecodedSyn))
		(DecodedSyn4 ((_ extract 4 4) DecodedSyn))
		(DecodedSyn5 ((_ extract 5 5) DecodedSyn))
		(DecodedSyn6 ((_ extract 6 6) DecodedSyn))
		(DecodedSyn7 ((_ extract 7 7) DecodedSyn))
		(DecodedSyn8 ((_ extract 8 8) DecodedSyn))
		(DecodedSyn9 ((_ extract 9 9) DecodedSyn))
		(DecodedSyn10 ((_ extract 10 10) DecodedSyn))
		(DecodedSyn11 ((_ extract 11 11) DecodedSyn))
		(DecodedSyn12 ((_ extract 12 12) DecodedSyn))
		(DecodedSyn13 ((_ extract 13 13) DecodedSyn))
		(DecodedSyn14 ((_ extract 14 14) DecodedSyn))
		(DecodedSyn15 ((_ extract 15 15) DecodedSyn))
	)
	(let
	(
		(OutDataBus0 (bvxor InDataBus0 DecodedSyn0))
		(OutDataBus1 (bvxor InDataBus1 DecodedSyn1))
		(OutDataBus2 (bvxor InDataBus2 DecodedSyn2))
		(OutDataBus3 (bvxor InDataBus3 DecodedSyn3))
		(OutDataBus4 (bvxor InDataBus4 DecodedSyn4))
		(OutDataBus5 (bvxor InDataBus5 DecodedSyn5))
		(OutDataBus6 (bvxor InDataBus6 DecodedSyn6))
		(OutDataBus7 (bvxor InDataBus7 DecodedSyn7))
		(OutDataBus8 (bvxor InDataBus8 DecodedSyn8))
		(OutDataBus9 (bvxor InDataBus9 DecodedSyn9))
		(OutDataBus10 (bvxor InDataBus10 DecodedSyn10))
		(OutDataBus11 (bvxor InDataBus11 DecodedSyn11))
		(OutDataBus12 (bvxor InDataBus12 DecodedSyn12))
		(OutDataBus13 (bvxor InDataBus13 DecodedSyn13))
		(OutDataBus14 (bvxor InDataBus14 DecodedSyn14))
		(OutDataBus15 (bvxor InDataBus15 DecodedSyn15))
	)
	(let
	(
		(out (concat OutDataBus15 OutDataBus14 OutDataBus13 OutDataBus12 OutDataBus11 OutDataBus10 OutDataBus9 OutDataBus8 OutDataBus7
		OutDataBus6 OutDataBus5 OutDataBus4 OutDataBus3 OutDataBus2 OutDataBus1 OutDataBus0))
	)
	)))
)

;--------------
(define-fun SynCheckSlice ((SynBits_i(_ BitVec 1)) (AllExtSynBits_i(_ BitVec 1)) (CorrectionFlag(_ BitVec 1)) (ContE(_ BitVec 1)) (Not_ContF(_ BitVec 1)) (ContB(_ BitVec 1))) (_ BitVec 1)
	(let
	(
		(line0 (bvand AllExtSynBits_i ContE CorrectionFlag))
	)
	(let
	(
		(line1 (bvxor SynBits_i line0))
	)
	(let
	(
		(line2 (bvnand Not_ContF ContB))
	)
	(let
	(
		(OutSynCheckBits_i (bvand line2 line1))
	)
	))))
)

(define-fun SynCheckGenerator ((SynBits(_ BitVec 6)) (AllExtSynBits(_ BitVec 6)) (CorrectionFlag(_ BitVec 1)) (ContE(_ BitVec 1)) (ContF(_ BitVec 1)) (ContB(_ BitVec 1))) (_ BitVec 6)
	(let
	(
		(SynBits0 ((_ extract 0 0) SynBits))
		(SynBits1 ((_ extract 1 1) SynBits))
		(SynBits2 ((_ extract 2 2) SynBits))
		(SynBits3 ((_ extract 3 3) SynBits))
		(SynBits4 ((_ extract 4 4) SynBits))
		(SynBits5 ((_ extract 5 5) SynBits))
		
		(AllExtSynBits0 ((_ extract 0 0) AllExtSynBits))
		(AllExtSynBits1 ((_ extract 1 1) AllExtSynBits))
		(AllExtSynBits2 ((_ extract 2 2) AllExtSynBits))
		(AllExtSynBits3 ((_ extract 3 3) AllExtSynBits))
		(AllExtSynBits4 ((_ extract 4 4) AllExtSynBits))
		(AllExtSynBits5 ((_ extract 5 5) AllExtSynBits))
	)
	(let
	(
		(Not_ContF (bvnot ContF))
	)
	(let
	(
		(OutSynCheckBits0 (SynCheckSlice SynBits0 AllExtSynBits0 CorrectionFlag ContE Not_ContF ContB))
		(OutSynCheckBits1 (SynCheckSlice SynBits1 AllExtSynBits1 CorrectionFlag ContE Not_ContF ContB))
		(OutSynCheckBits2 (SynCheckSlice SynBits2 AllExtSynBits2 CorrectionFlag ContE Not_ContF ContB))
		(OutSynCheckBits3 (SynCheckSlice SynBits3 AllExtSynBits3 CorrectionFlag ContE Not_ContF ContB))
		(OutSynCheckBits4 (SynCheckSlice SynBits4 AllExtSynBits4 CorrectionFlag ContE Not_ContF ContB))
		(OutSynCheckBits5 (SynCheckSlice SynBits5 AllExtSynBits5 CorrectionFlag ContE Not_ContF ContB))
	)
	(let
	(
		(out (concat OutSynCheckBits5 OutSynCheckBits4 OutSynCheckBits3 OutSynCheckBits2 OutSynCheckBits1 OutSynCheckBits0))
	)
	))))
)

;--------------------------
(define-fun ByteParity ((InDBParity_N(_ BitVec 1)) (InCheckBit_N(_ BitVec 1)) (CorrectionFlag_N(_ BitVec 1)) (ContB(_ BitVec 1)) (Cont_N(_ BitVec 1))) (_ BitVec 1)
	(let
	(
		(Not_ContB (bvnot ContB))
		(Not_Cont_N (bvnot Cont_N))
		(Not_InDBParity_N (bvnot InDBParity_N))
	)
	(let
	(
		(line3 (bvnand ContB Not_Cont_N))
	)
	(let
	(
		(line4 (bvand line3 Not_InDBParity_N))
		(line5 (bvand CorrectionFlag_N Not_ContB))
	)
	(let
	(
		(line6 (bvxor line4 line5))
		(line7 (bvnand InCheckBit_N Cont_N))
	)
	(let
	(
		(line8 (bvand line7 ContB))
	)
	(let
	(
		(ByteParity_N (bvxor line6 line8))
	)
	))))))
)

;--------------------------------------------
(define-fun UEGen ((ProductSyn(_ BitVec 12)) (ContIntUE(_ BitVec 1)) (NotM(_ BitVec 1)) (NotP(_ BitVec 1)) (NotNewSynBit3(_ BitVec 1)) (NotNewSynBit5(_ BitVec 1))) (_ BitVec 1)
	(let
	(
		(ProductSyn0 ((_ extract 0 0) ProductSyn))
		(ProductSyn1 ((_ extract 1 1) ProductSyn))
		(ProductSyn2 ((_ extract 2 2) ProductSyn))
		(ProductSyn3 ((_ extract 3 3) ProductSyn))
		(ProductSyn4 ((_ extract 4 4) ProductSyn))
		(ProductSyn5 ((_ extract 5 5) ProductSyn))
		(ProductSyn6 ((_ extract 6 6) ProductSyn))
		(ProductSyn7 ((_ extract 7 7) ProductSyn))
		(ProductSyn8 ((_ extract 8 8) ProductSyn))
		(ProductSyn9 ((_ extract 9 9) ProductSyn))
		(ProductSyn10 ((_ extract 10 10) ProductSyn))
		(ProductSyn11 ((_ extract 11 11) ProductSyn))
	)
	(let
	(
		(line0 (bvand NotP NotNewSynBit3))
		(line1 (bvand NotM NotNewSynBit5))
	)
	(let
	(
		(line2 (bvnot (bvand ProductSyn0 ProductSyn6 ProductSyn2 ProductSyn1 ContIntUE)))
		(line3 (bvnot (bvand ProductSyn8 ProductSyn10 ProductSyn2 ProductSyn1 ContIntUE)))
		(line4 (bvnot (bvand ProductSyn8 ProductSyn6 ProductSyn9 ProductSyn1 ContIntUE)))
		(line5 (bvnot (bvand ProductSyn8 ProductSyn6 ProductSyn2 ProductSyn3 ContIntUE)))
		(line6 (bvnot (bvand ProductSyn8 ProductSyn6 ProductSyn2 ProductSyn4 ContIntUE)))
		(line7 (bvnot (bvand ProductSyn8 ProductSyn6 ProductSyn5 ProductSyn1 ContIntUE)))
		(line8 (bvnot (bvand ProductSyn8 line0 ProductSyn2 ProductSyn1 ContIntUE)))
		(line9 (bvnot (bvand line1 ProductSyn6 ProductSyn2 ProductSyn1 ContIntUE)))
	)
	(let
	(
		(UESignal (bvand line2 line3 line4 line5 line6 line7 line8 line9))
	)
	))))
)

(define-fun UncorrErrorGenerator ((ProductSyn(_ BitVec 12)) (Not_NewSynBits(_ BitVec 6)) (CorrectionFlagHi(_ BitVec 1)) (CorrectionFlagLo(_ BitVec 1)) (InCheckBit1(_ BitVec 1)) (InCheckBit4(_ BitVec 1)) (ContE(_ BitVec 1)) (ContF(_ BitVec 1)) (ContB(_ BitVec 1)) (ContG(_ BitVec 1)) (ContH(_ BitVec 1)) (ContIntM(_ BitVec 1)) (ContIntP(_ BitVec 1))) (_ BitVec 1)
	(let
	(		
		(Not_NewSynBits0 ((_ extract 0 0) Not_NewSynBits))
		(Not_NewSynBits1 ((_ extract 1 1) Not_NewSynBits))
		(Not_NewSynBits2 ((_ extract 2 2) Not_NewSynBits))
		(Not_NewSynBits3 ((_ extract 3 3) Not_NewSynBits))
		(Not_NewSynBits4 ((_ extract 4 4) Not_NewSynBits))
		(Not_NewSynBits5 ((_ extract 5 5) Not_NewSynBits))
	)
	(let
	(
		(Not_ContH (bvnot ContH))
		(Not_ContE (bvnot ContE))
		(Not_ContB (bvnot ContB))
		(Not_ContF (bvnot ContF))
		(NotM (bvnot ContIntM))
		(NotP (bvnot ContIntP))
	)
	(let
	(
		(NotGH (bvnand ContG ContH))
	)
	(let
	(
		(ContIntUE (bvand ContF Not_ContB NotGH))
	)
	(let
	(
		(UESignal (UEGen ProductSyn ContIntUE NotM NotP Not_NewSynBits3 Not_NewSynBits5))
	)
	(let
	(
		(line9 (bvnand Not_ContH Not_ContE ))
	)
	(let
	(
		(line10 (bvnand line9 InCheckBit1))
		(line11 (bvnand ContG Not_ContE))
	)
	(let
	(
		(line12 (bvnand InCheckBit4 line11))
	)
	(let
	(
		(ErrorFREE (bvnot (bvand Not_NewSynBits0 Not_NewSynBits1 Not_NewSynBits2 Not_NewSynBits3 Not_NewSynBits4 Not_NewSynBits5 line10 line12)))
	)
	(let
	(
		(NotCorrFlagHi (bvnot CorrectionFlagHi))
		(NotCorrFlagLo (bvnot CorrectionFlagLo))
	)
	(let
	(
		(line16 (bvand NotCorrFlagLo NotCorrFlagHi UESignal))
	)
	(let
	(
		(line17 (bvand Not_ContB ErrorFREE ContF line16))
		(line18 (bvand Not_ContB ErrorFREE Not_ContF))
	)
	(let
	(
		(UncorrError (bvnor line17 line18))
	)
	)))))))))))))
)

(assert
	(not
		(let
			(
				(v0 ((_ extract 0 0) virus))
				(v1 ((_ extract 1 1) virus))
				(v2 ((_ extract 2 2) virus))
				(v3 ((_ extract 3 3) virus))
				(v4 ((_ extract 4 4) virus))
				(v5 ((_ extract 5 5) virus))
				(v6 ((_ extract 6 6) virus))
				
				(notContK_T (bvnot ContK_T))
				(nontrojan (concat InCheckBits_T ContK_T ContL_T))
			)
		(let
			(
				(trojan0 (concat zero v6 v5 v4 v3 v2 v1 v0))
				(trojan1 (concat one v6 v5 v4 v3 v2 v1 v0))
			)
		(let
			(
				(temp10 (mux2to1 trojan0 nontrojan notContK_T))
				(temp20 (mux2to1 nontrojan trojan0 notContK_T))
				(temp11 (mux2to1 trojan1 nontrojan notContK_T))
				(temp21 (mux2to1 nontrojan trojan1 notContK_T))
			)
		(let
			(
				(ic0 (mux2to1 temp10 temp20 ContK_T))
				(ic1 (mux2to1 temp11 temp21 ContK_T))
			)
		(let
			(
				(ContL_0 ((_ extract 0 0) ic0))
				(ContK_0 ((_ extract 1 1) ic0))
				(InCheckBits_0 ((_ extract 7 2) ic0))
				(ContL_1 ((_ extract 0 0) ic1))
				(ContK_1 ((_ extract 1 1) ic1))
				(InCheckBits_1 ((_ extract 7 2) ic1))
			)
		(let
			(
				(temp0 (SyndromeGenerator InDataBus InCheckBits_0 ContB ContG ContH))
				(temp1 (SyndromeGenerator InDataBus InCheckBits_1 ContB ContG ContH))
			)
		(let
			(
				(SynBits_0 ((_ extract 7 2) temp0))
				(InDBParityHi_0 ((_ extract 1 1) temp0))
				(InDBParityLo_0 ((_ extract 0 0) temp0))
				(SynBits_1 ((_ extract 7 2) temp1))
				(InDBParityHi_1 ((_ extract 1 1) temp1))
				(InDBParityLo_1 ((_ extract 0 0) temp1))
			)
		(let
			(
				(out0 (ModifySyndrome SynBits_0 InExtSynBits InCheckBits_0 ContE ContG ContH))
				(out1 (ModifySyndrome SynBits_1 InExtSynBits InCheckBits_1 ContE ContG ContH))
			)
		(let
			(
				(S1_0 (concat (_ bv0 21) InDataBus InCheckBits_0 InExtSynBits ContE ContB ContF ContG ContH ContK_0 ContL_0 SynBits_0 InDBParityHi_0 InDBParityLo_0 out0))
				(S1_1 (concat (_ bv0 21) InDataBus InCheckBits_1 InExtSynBits ContE ContB ContF ContG ContH ContK_1 ContL_1 SynBits_1 InDBParityHi_1 InDBParityLo_1 out1))
			)
		(let
			(
				(array0 (store array0 (_ bv0 2) S1_0))
				(array1 (store array1 (_ bv0 2) S1_1))
			)
             ;----------------------------------------------------------------------------------------------
		(let
			(
				(NewSynBits_0 ((_ extract 19 14) out0))
				(NotNewSynBits_0 ((_ extract 13 8) out0))
				(AllExtSynBits_0 ((_ extract 7 2) out0))
				(ContIntM_0 ((_ extract 1 1) out0))
				(ContIntP_0 ((_ extract 0 0) out0))
				
				(NewSynBits_1 ((_ extract 19 14) out1))
				(NotNewSynBits_1 ((_ extract 13 8) out1))
				(AllExtSynBits_1 ((_ extract 7 2) out1))
				(ContIntM_1 ((_ extract 1 1) out1))
				(ContIntP_1 ((_ extract 0 0) out1))
			)
		(let
			(
				(temp0 (SyndromeDecode NewSynBits_0 NotNewSynBits_0 ContIntM_0 ContIntP_0 ContE ContB ContF ContG ContH ContK_0 ContL_0))
				(temp1 (SyndromeDecode NewSynBits_1 NotNewSynBits_1 ContIntM_1 ContIntP_1 ContE ContB ContF ContG ContH ContK_1 ContL_1))
			)
		(let
			(
				(CorrectionFlagLo_0 ((_ extract 0 0) temp0))
				(CorrectionFlagHi_0 ((_ extract 1 1) temp0))
				(CorrectionFlag_0 ((_ extract 2 2) temp0))
				(ProductSyn_0 ((_ extract 14 3) temp0))
				(DecodedSyn_0 ((_ extract 30 15) temp0))
				
				(CorrectionFlagLo_1 ((_ extract 0 0) temp1))
				(CorrectionFlagHi_1 ((_ extract 1 1) temp1))
				(CorrectionFlag_1 ((_ extract 2 2) temp1))
				(ProductSyn_1 ((_ extract 14 3) temp1))
				(DecodedSyn_1 ((_ extract 30 15) temp1))
			)
		(let
			(
				(OutDataBus_0 (DataBusCorrect InDataBus DecodedSyn_0))
				(OutDataBus_1 (DataBusCorrect InDataBus DecodedSyn_1))
			)
		(let
			(
				(S2_0 (concat OutDataBus_0 DecodedSyn_0 ProductSyn_0 CorrectionFlag_0 CorrectionFlagHi_0 CorrectionFlagLo_0 SynBits_0 AllExtSynBits_0 InDBParityHi_0 InDBParityLo_0 NotNewSynBits_0 InCheckBits_0 ContE ContB ContF ContG ContH ContK_0 ContL_0 ContIntM_0 ContIntP_0))
				(S2_1 (concat OutDataBus_1 DecodedSyn_1 ProductSyn_1 CorrectionFlag_1 CorrectionFlagHi_1 CorrectionFlagLo_1 SynBits_1 AllExtSynBits_1 InDBParityHi_1 InDBParityLo_1 NotNewSynBits_1 InCheckBits_1 ContE ContB ContF ContG ContH ContK_1 ContL_1 ContIntM_1 ContIntP_1))
			)
		(let
			(
				(array0 (store array0 (_ bv1 2) S2_0))
				(array1 (store array1 (_ bv1 2) S2_1))
			)
          ;-----------------------------------------------------------------------------------------------
		(let
			(
				(OutSynCheckBits_0 (SynCheckGenerator SynBits_0 AllExtSynBits_0 CorrectionFlag_0 ContE ContF ContB))
				(OutSynCheckBits_1 (SynCheckGenerator SynBits_1 AllExtSynBits_1 CorrectionFlag_1 ContE ContF ContB))
			)
		(let
			(
				(InCheckBits1_0 ((_ extract 1 1) InCheckBits_0))
				(InCheckBits3_0 ((_ extract 3 3) InCheckBits_0))
				(InCheckBits4_0 ((_ extract 4 4) InCheckBits_0))
				(InCheckBits5_0 ((_ extract 5 5) InCheckBits_0))
				
				(InCheckBits1_1 ((_ extract 1 1) InCheckBits_1))
				(InCheckBits3_1 ((_ extract 3 3) InCheckBits_1))
				(InCheckBits4_1 ((_ extract 4 4) InCheckBits_1))
				(InCheckBits5_1 ((_ extract 5 5) InCheckBits_1))
			)
		(let
			(
				(ByteParHi_0 (ByteParity InDBParityHi_0 InCheckBits3_0 CorrectionFlagHi_0 ContB ContL_0))
				(ByteParLo_0 (ByteParity InDBParityLo_0 InCheckBits5_0 CorrectionFlagLo_0 ContB ContK_0))
				
				(ByteParHi_1 (ByteParity InDBParityHi_1 InCheckBits3_1 CorrectionFlagHi_1 ContB ContL_1))
				(ByteParLo_1 (ByteParity InDBParityLo_1 InCheckBits5_1 CorrectionFlagLo_1 ContB ContK_1))
			)
		(let
			(
				(S3_0 (concat (_ bv0 29) ByteParHi_0 ByteParLo_0 OutSynCheckBits_0 OutDataBus_0 ProductSyn_0 NotNewSynBits_0 CorrectionFlagHi_0 CorrectionFlagLo_0 InCheckBits1_0 InCheckBits4_0 ContE ContF ContB ContG ContH ContIntM_0 ContIntP_0))
				(S3_1 (concat (_ bv0 29) ByteParHi_1 ByteParLo_1 OutSynCheckBits_1 OutDataBus_1 ProductSyn_1 NotNewSynBits_1 CorrectionFlagHi_1 CorrectionFlagLo_1 InCheckBits1_1 InCheckBits4_1 ContE ContF ContB ContG ContH ContIntM_1 ContIntP_1))
			)
		(let
			(
				(array0 (store array0 (_ bv2 2) S3_0))
				(array1 (store array1 (_ bv2 2) S3_1))
			)
           ;-----------------------------------------------------------------------------------------------
		(let
			(
				(UncorrError_0 (UncorrErrorGenerator ProductSyn_0 NotNewSynBits_0 CorrectionFlagHi_0 CorrectionFlagLo_0 InCheckBits1_0 InCheckBits4_0 ContE ContF ContB ContG ContH ContIntM_0 ContIntP_0))
				(UncorrError_1 (UncorrErrorGenerator ProductSyn_1 NotNewSynBits_1 CorrectionFlagHi_1 CorrectionFlagLo_1 InCheckBits1_1 InCheckBits4_1 ContE ContF ContB ContG ContH ContIntM_1 ContIntP_1))
			)
		(let
			(
				(finalout0 (concat (_ bv0 57) OutDataBus_0 OutSynCheckBits_0 ByteParHi_0 ByteParLo_0 UncorrError_0))
				(finalout1 (concat (_ bv0 57) OutDataBus_1 OutSynCheckBits_1 ByteParHi_1 ByteParLo_1 UncorrError_1))
			)
		(let
			(
				(array0 (store array0 (_ bv3 2) finalout0))
				(array1 (store array1 (_ bv3 2) finalout1))
			)
		(=>
			(and (= zero (_ bv0 1)) (= one (_ bv1 1)))
			(= array0 array1)
		)))))))))))))))))))))))))
	)
)

(check-sat)
(get-model)