(define-fun Mux10bit_4_1 ((In1bus(_ BitVec 10)) (In2bus(_ BitVec 10)) (In3bus(_ BitVec 10)) (In4bus(_ BitVec 10)) (Cont0(_ BitVec 1)) (Cont1(_ BitVec 1)) ) (_ BitVec 10)
	(let
		(
			(sel (concat Cont1 Cont0))
		)
	(let
		(
			(output (ite (= sel (_ bv0 2)) In1bus 
						(ite (= sel (_ bv1 2)) In2bus
							(ite (= sel (_ bv2 2)) In3bus In4bus))))
		)
	))
)

(define-fun ContSignalGen ((Bbus4(_ BitVec 1)) (Bbus5(_ BitVec 1)) (Bbus4(_ BitVec 1)) (ContMask1(_ BitVec 1)) (ContMask2(_ BitVec 1)) ) (_ BitVec 2)
	(let
		(
			(NotB5 (bvnot Bbus5))
			(NotMask1 (bvnot ContMask1))
		)
	(let
		(
			(line2 (bvand Bbus4 NotMask1))
		)
	(let
		(
			(ContAlpha (bvand NotB5 line2 ContMask2))
		)
	(let
		(
			(line4 (bvnot line2))
		)
	(let
		(
			(ContBeta (bvand ContMask2 line4 NotB5))
		)
	(let
		(
			(output (concat ContBeta ContAlpha))
		)
	))))))
)

(define-fun CompareXY ((Xbus(_ BitVec 11)) (Ybus(_ BitVec 11)) (ContAlpha(_ BitVec 1)) (ContBeta(_ BitVec 1)) (ContMask0(_ BitVec 1)) ) (_ BitVec 3)
	(let
		(
			(XMbus (MaskBus Xbus ContAlpha ContBeta ContMask0))
			(YMbus (MaskBus Ybus ContAlpha ContBeta ContMask0))
		)
	(let
		(
			(Not_XMbus (Invert12 XMbus))
		)
	(let
		(
			(YgX1 (CLA12_XY Not_XMbus YMbus))
			(YgX2 (CLA12_XY Not_XMbus YMbus))
		)
	(let
		(
			(OutYgreaterX (bvor YgX1 YgX1))
		)
	(let
		(
			(Not_CompCLAs (XOR2b YgX1 YgX2))
		)
	(let
		(
			(CompCLAs (RedundantInv Not_CompCLAs))
		)
	(let
		(
			(OutYgreaterX_Equal (bvnot CompCLAs))
		)
	(let
		(
			(output (concat OutYgreaterX OutYgreaterX_Equal CompCLAs))
		)
	))))))))
)

(define-fun MaskBus ((Inbus(_ BitVec 12)) (ContAlpha(_ BitVec 1)) (ContBeta(_ BitVec 1)) (ContMask0(_ BitVec 1)) ) (_ BitVec 12)
	(let
		(
			(Inbus03 ((_ extract 3 0) Inbus))
			(Inbus4 ((_ extract 4 4) Inbus))
			(Inbus5 ((_ extract 5 5) Inbus))
			(Inbus6 ((_ extract 6 6) Inbus))
			(Inbus7 ((_ extract 7 7) Inbus))
			(Inbus8 ((_ extract 8 8) Inbus))
			(Inbus9 ((_ extract 9 9) Inbus))
			(Inbus10 ((_ extract 10 10) Inbus))
			(Inbus11 ((_ extract 11 11) Inbus))
		)
	(let
		(
			(OutMbus4 (bvand Inbus4 ContMask0))
			(OutMbus5 (bvand Inbus5 ContMask0))
			(NotAlpha (bvnot ContAlpha))
		)
	(let
		(
			(line3 (bvand Inbus6 NotAlpha))
		)
	(let
		(
			(OutMbus6 (bvand line3 ContMask0))
			(line5 (bvand Inbus7 NotAlpha))
		)
	(let
		(
			(OutMbus7 (bvand line5 ContMask0))
		)
	(let
		(
			(line7 (bvand Inbus8 NotAlpha))
		)
	(let
		(
			(OutMbus8 (bvand line7 ContBeta))
			(line9 (bvand Inbus9 NotAlpha))
		)
	(let
		(
			(OutMbus9 (bvand line9 ContBeta))
			(line11 (bvand Inbus10 NotAlpha))
		)
	(let
		(
			(OutMbus10 (bvand line11 ContBeta))
			(line13 (bvand Inbus11 NotAlpha))
		)
	(let
		(
			(OutMbus11 (bvand line13 ContBeta))
		)
	(let
		(
			(output (concat OutMbus11 OutMbus10 OutMbus9 OutMbus8 OutMbus7 OutMbus6 OutMbus5 OutMbus4 Inbus03))
		)
	)))))))))))
)

(define-fun Invert12 ((Xbus(_ BitVec 12)) ) (_ BitVec 12)
	(let
		(
			(Xbus0 ((_ extract 0 0) Xbus))
			(Xbus1 ((_ extract 1 1) Xbus))
			(Xbus2 ((_ extract 2 2) Xbus))
			(Xbus3 ((_ extract 3 3) Xbus))
			(Xbus4 ((_ extract 4 4) Xbus))
			(Xbus5 ((_ extract 5 5) Xbus))
			(Xbus6 ((_ extract 6 6) Xbus))
			(Xbus7 ((_ extract 7 7) Xbus))
			(Xbus8 ((_ extract 8 8) Xbus))
			(Xbus9 ((_ extract 9 9) Xbus))
			(Xbus10 ((_ extract 10 10) Xbus))
			(Xbus11 ((_ extract 11 11) Xbus))
		)
	(let
		(
			(NotXbus0 (bvnot Xbus0))
			(NotXbus1 (bvnot Xbus1))
			(NotXbus2 (bvnot Xbus2))
			(NotXbus3 (bvnot Xbus3))
			(NotXbus4 (bvnot Xbus4))
			(NotXbus5 (bvnot Xbus5))
			(NotXbus6 (bvnot Xbus6))
			(NotXbus7 (bvnot Xbus7))
			(NotXbus8 (bvnot Xbus8))
			(NotXbus9 (bvnot Xbus9))
			(NotXbus10 (bvnot Xbus10))
			(NotXbus11 (bvnot Xbus11))
		)
	(let
		(
			(output (concat NotXbus11 NotXbus10 NotXbus9 NotXbus8 NotXbus7 NotXbus6 NotXbus5 NotXbus4 NotXbus3 NotXbus2 NotXbus1 NotXbus0))
		)
	)))
)

(define-fun CLA12_XY ((In1bus(_ BitVec 12)) (In2bus(_ BitVec 12)) ) (_ BitVec 1)
	(let
		(
			(PGbus (CalcGP In1bus In2bus))
		)
	(let
		(
			(Gbus ((_ extract 11 0) PGbus))
			(Pbus ((_ extract 23 12) PGbus))
		)
	(let
		(
			(output (CLACarry12_Cin0 Gbus Pbus))
		)
	)))
)

(define-fun CalcGP ((In1bus(_ BitVec 12)) (In2bus(_ BitVec 12)) ) (_ BitVec 24)
	(let
		(
			(In1bus0 ((_ extract  0 0) In1bus))			
			(In1bus1 ((_ extract  1 1) In1bus))
			(In1bus2 ((_ extract  2 2) In1bus))
			(In1bus3 ((_ extract  3 3) In1bus))
			(In1bus4 ((_ extract  4 4) In1bus))
			(In1bus5 ((_ extract  5 5) In1bus))
			(In1bus6 ((_ extract  6 6) In1bus))
			(In1bus7 ((_ extract  7 7) In1bus))
			(In1bus8 ((_ extract  8 8) In1bus))
			(In1bus9 ((_ extract  9 9) In1bus))
			(In1bus10 ((_ extract  10 10) In1bus))
			(In1bus11 ((_ extract  11 11) In1bus))
			
			(In2bus0 ((_ extract  0 0) In2bus))			
			(In2bus1 ((_ extract  1 1) In2bus))
			(In2bus2 ((_ extract  2 2) In2bus))
			(In2bus3 ((_ extract  3 3) In2bus))
			(In2bus4 ((_ extract  4 4) In2bus))
			(In2bus5 ((_ extract  5 5) In2bus))
			(In2bus6 ((_ extract  6 6) In2bus))
			(In2bus7 ((_ extract  7 7) In2bus))
			(In2bus8 ((_ extract  8 8) In2bus))
			(In2bus9 ((_ extract  9 9) In2bus))
			(In2bus10 ((_ extract  10 10) In2bus))
			(In2bus11 ((_ extract  11 11) In2bus))
		)
	(let
		(
			(Gbus0 (bvand In1bus0 In2bus0))			
			(Gbus1 (bvand In1bus1 In2bus1))
			(Gbus2 (bvand In1bus2 In2bus2))
			(Gbus3 (bvand In1bus3 In2bus3))
			(Gbus4 (bvand In1bus4 In2bus4))
			(Gbus5 (bvand In1bus5 In2bus5))
			(Gbus6 (bvand In1bus6 In2bus6))
			(Gbus7 (bvand In1bus7 In2bus7))
			(Gbus8 (bvand In1bus8 In2bus8))
			(Gbus9 (bvand In1bus9 In2bus9))
			(Gbus10 (bvand In1bus10 In2bus10))
			(Gbus11 (bvand In1bus11 In2bus11))
			
			(Pbus0 (bvxor In1bus0 In2bus0))			
			(Pbus1 (bvxor In1bus1 In2bus1))
			(Pbus2 (bvxor In1bus2 In2bus2))
			(Pbus3 (bvxor In1bus3 In2bus3))
			(Pbus4 (bvxor In1bus4 In2bus4))
			(Pbus5 (bvxor In1bus5 In2bus5))
			(Pbus6 (bvxor In1bus6 In2bus6))
			(Pbus7 (bvxor In1bus7 In2bus7))
			(Pbus8 (bvxor In1bus8 In2bus8))
			(Pbus9 (bvxor In1bus9 In2bus9))
			(Pbus10 (bvxor In1bus10 In2bus10))
			(Pbus11 (bvxor In1bus11 In2bus11))
		)
	(let
		(
			(output (concat Pbus11 Pbus10 Pbus9 Pbus8 Pbus7 Pbus6 Pbus5 Pbus4 Pbus3 Pbus2 Pbus1 Pbus0 Gbus11 Gbus10 Gbus9 Gbus8 Gbus7 Gbus6 Gbus5 Gbus4 Gbus3 Gbus2 Gbus1 Gbus0))
		)
	)))
)

(define-fun CLACarry3_Cin0 ((Gbus(_ BitVec 3)) (Pbus(_ BitVec 3)) ) (_ BitVec 1)
	(let
		(
			(Gbus0 ((_ extract  0 0) Gbus))			
			(Gbus1 ((_ extract  1 1) Gbus))
			(Gbus2 ((_ extract  2 2) Gbus))
			(Pbus0 ((_ extract  0 0) Pbus))			
			(Pbus1 ((_ extract  1 1) Pbus))
			(Pbus2 ((_ extract  2 2) Pbus))
		)
	(let
		(
			(line0 (bvand Pbus2 Gbus1))
			(line1 (bvand Pbus2 Pbus1 Gbus0))
		)
	(let
		(
			(output (bvor Gbus2 line0 line1))
		)
	)))
)

(define-fun CLACarry4_Cin0 ((Gbus(_ BitVec 4)) (Pbus(_ BitVec 4)) ) (_ BitVec 1)
	(let
		(
			(Gbus0 ((_ extract  0 0) Gbus))			
			(Gbus1 ((_ extract  1 1) Gbus))
			(Gbus2 ((_ extract  2 2) Gbus))
			(Gbus3 ((_ extract  3 3) Gbus))
			(Pbus0 ((_ extract  0 0) Pbus))			
			(Pbus1 ((_ extract  1 1) Pbus))
			(Pbus2 ((_ extract  2 2) Pbus))
			(Pbus3 ((_ extract  3 3) Pbus))	
		)
	(let
		(
			(line0 (bvand Pbus3 Gbus2))
			(line1 (bvand Pbus3 Pbus2 Gbus1))
			(line2 (bvand Pbus3 Pbus2 Pbus1 Gbus0))
		)
	(let
		(
			(output (bvor Gbus3 line2 line0 line1))
		)
	)))
)

(define-fun CLACarry5_Cin0 ((Gbus(_ BitVec 5)) (Pbus(_ BitVec 5)) ) (_ BitVec 1)
	(let
		(
			(Gbus0 ((_ extract  0 0) Gbus))			
			(Gbus1 ((_ extract  1 1) Gbus))
			(Gbus2 ((_ extract  2 2) Gbus))
			(Gbus3 ((_ extract  3 3) Gbus))
			(Gbus4 ((_ extract  4 4) Gbus))
			(Pbus0 ((_ extract  0 0) Pbus))			
			(Pbus1 ((_ extract  1 1) Pbus))
			(Pbus2 ((_ extract  2 2) Pbus))
			(Pbus3 ((_ extract  3 3) Pbus))	
			(Pbus4 ((_ extract  4 4) Pbus))
		)
	(let
		(
			(line0 (bvand Pbus4 Gbus3))
			(line1 (bvand Pbus4 Pbus3 Gbus2))
			(line2 (bvand Pbus4 Pbus3 Pbus2 Gbus1))
			(line3 (bvand Pbus4 Pbus3 Pbus2 Pbus1 Gbus0))
		)
	(let
		(
			(output (bvor Gbus4 line3 line2 line0 line1))
		)
	)))
)

(define-fun CLACarry12_Cin0 ((Gbus(_ BitVec 12)) (Pbus(_ BitVec 12)) ) (_ BitVec 1)
	(let
		(
			(Gbus0 ((_ extract  0 0) Gbus))			
			(Gbus1 ((_ extract  1 1) Gbus))
			(Gbus2 ((_ extract  2 2) Gbus))
			(Gbus3 ((_ extract  3 3) Gbus))
			(Gbus4 ((_ extract  4 4) Gbus))
			(Gbus5 ((_ extract  5 5) Gbus))
			(Gbus6 ((_ extract  6 6) Gbus))
			(Gbus7 ((_ extract  7 7) Gbus))
			(Gbus8 ((_ extract  8 8) Gbus))
			(Gbus9 ((_ extract  9 9) Gbus))
			(Gbus10 ((_ extract  10 10) Gbus))
			(Gbus11 ((_ extract  11 11) Gbus))
			
			(Pbus0 ((_ extract  0 0) Pbus))			
			(Pbus1 ((_ extract  1 1) Pbus))
			(Pbus2 ((_ extract  2 2) Pbus))
			(Pbus3 ((_ extract  3 3) Pbus))
			(Pbus4 ((_ extract  4 4) Pbus))
			(Pbus5 ((_ extract  5 5) Pbus))
			(Pbus6 ((_ extract  6 6) Pbus))
			(Pbus7 ((_ extract  7 7) Pbus))
			(Pbus8 ((_ extract  8 8) Pbus))
			(Pbus9 ((_ extract  9 9) Pbus))
			(Pbus10 ((_ extract  10 10) Pbus))
			(Pbus11 ((_ extract  11 11) Pbus))
		)
	(let
		(
			(Gbus_3bit (concat Gbus2 Gbus1 Gbus0))
			(Pbus_3bit (concat Pbus2 Pbus1 Pbus0))
			(Gbus_5bit (concat Gbus7 Gbus6 Gbus5 Gbus4 Gbus3))
			(Pbus_5bit (concat Pbus7 Pbus6 Pbus5 Pbus4 Pbus3))
			(Gbus_4bit (concat Gbus11 Gbus10 Gbus9 Gbus8))
			(Pbus_4bit (concat Pbus11 Pbus10 Pbus9 Pbus8))
		)
	(let
		(
			(OutCarry2_0 (CLACarry3_Cin0 Gbus_3bit Pbus_3bit))
			(OutCarry7_3 (CLACarry5_Cin0 Gbus_5bit Pbus_5bit))
			(OutCarry11_8 (CLACarry4_Cin0 Gbus_4bit Pbus_4bit))
		)
	(let
		(
			(Prop7_3 (bvand Pbus3 Pbus4 Pbus5 Pbus6 Pbus7))
			(Prop11_8 (bvand Pbus8 Pbus9 Pbus10 Pbus11))
		)
	(let
		(
			(line5 (bvand Prop7_3 OutCarry2_0))
		)
	(let
		(
			(OutCarry7_0 (bvor OutCarry7_3 line5))
		)
	(let
		(
			(NotOutCarry7_0 (bvnot OutCarry7_0))
			(line8 (bvor OutCarry11_8 Prop11_8))
		)
	(let
		(
			(line9 (bvand NotOutCarry7_0 OutCarry11_8))
			(line10 (bvand line8 OutCarry7_0))
		)
	(let
		(
			(output (bvor line9 line10))
		)
	)))))))))
)

(define-fun XOR2b ((A(_ BitVec 1)) (B(_ BitVec 1)) ) (_ BitVec 1)
	(let
		(
			(NotAB (bvnand A B))
		)
	(let
		(
			(line1 (bvand A NotAB))
			(line2 (bvand B NotAB))
		)
	(let
		(
			(output (bvor line1 line2))
		)
	)))
)

(define-fun RedundantInv ((A(_ BitVec 1)) ) (_ BitVec 1)
	(let
		(
			(NotA (bvnot A))
		)
	(let
		(
			(line1 (bvand A NotA))
		)
	(let
		(
			(output (bvor line1 NotA))
		)
	)))
)

