(set-logic QF_ABV)
;--------------main moemories----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(declare-fun instruction_memory () (Array (_ BitVec 32) (_ BitVec 32)))
(declare-fun regfile () (Array (_ BitVec 5) (_ BitVec 32)))
(declare-fun datamemory () (Array (_ BitVec 32) (_ BitVec 32)))

;-----------------------testing declarations-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(declare-fun P () (_ BitVec 637))
(declare-fun flush () (_ BitVec 1))
(declare-fun noflush () (_ BitVec 1))
(declare-fun bit_0 () (_ BitVec 1))
(declare-fun bit_1 () (_ BitVec 1))
;-----------------------------sub functions--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun signextender ((sign(_ BitVec 16))) (_ BitVec 32)
	(let
		(
			(lastbit ((_ extract 15 15) sign))
		)
	(let
		(
			(signextenion
				(ite (= lastbit (_ bv0 1)) (_ bv0 16)
					(_ bv65535 16)
			))
		)
	(let
		(
			(signextended (concat signextenion sign))
		)
	)))
	
)
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_regfile ( (a(Array (_ BitVec 5) (_ BitVec 32))) (b(Array (_ BitVec 5) (_ BitVec 32))) (s(_ BitVec 1))) (Array (_ BitVec 5) (_ BitVec 32))
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b a ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_datamemory ( (a(Array (_ BitVec 32) (_ BitVec 32))) (b(Array (_ BitVec 32) (_ BitVec 32))) (s(_ BitVec 1))) (Array (_ BitVec 32) (_ BitVec 32))
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b a ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1 ( (a(_ BitVec 32)) (b(_ BitVec 32)) (s(_ BitVec 1))) (_ BitVec 32)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 32) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_64bit ( (a(_ BitVec 64)) (b(_ BitVec 64)) (s(_ BitVec 1))) (_ BitVec 64)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 64) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_5bit ( (a(_ BitVec 5)) (b(_ BitVec 5)) (s(_ BitVec 1))) (_ BitVec 5)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 5) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_1bit ( (a(_ BitVec 1)) (b(_ BitVec 1)) (s(_ BitVec 1))) (_ BitVec 1)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 1) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_2bit ( (a(_ BitVec 2)) (b(_ BitVec 2)) (s(_ BitVec 1))) (_ BitVec 2)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 2) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun mux2to1_28bit ( (a(_ BitVec 28)) (b(_ BitVec 28)) (s(_ BitVec 1))) (_ BitVec 28)
	(ite (= s (_ bv0 1)) a
		(ite (= s (_ bv1 1)) b (_ bv0 28) ))
)

;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
(define-fun mux4to1 ( (a(_ BitVec 32)) (b(_ BitVec 32)) (c(_ BitVec 32)) (d(_ BitVec 32)) (s(_ BitVec 2))) (_ BitVec 32)
	(ite (= s (_ bv0 2)) a 
		(ite (= s (_ bv1 2)) b 
			(ite (= s (_ bv2 2)) c
				(ite (= s (_ bv3 2)) d (_ bv0 32)  ))))
)
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
(define-fun floatingpoint ((x(_ BitVec 32)) (y(_ BitVec 32)) (add_sub(_ BitVec 1))) (_ BitVec 32)
	(let
		(
			(x_signbit ((_ extract 31 31) x))
			(y_signbit ((_ extract 31 31) y))
			(x_exponent ((_ extract 30 23) x))
			(y_exponent ((_ extract 30 23) y))
			(x_mantissa ((_ extract 22 0) x))
			(y_mantissa ((_ extract 22 0) y))
		)
	(let
		(
			(shift_wrt_x (bvsub x_exponent y_exponent))
			(shift_wrt_y (bvsub y_exponent x_exponent))
		)
	(let
		(
			(shift_wrt_x-1 (bvsub shift_wrt_x (_ bv1 8)))
			(shift_wrt_y-1 (bvsub shift_wrt_y (_ bv1 8)))
		)
	(let
		(
			(shifting_wrtx-1 (concat (_ bv0 15) shift_wrt_x-1))
			(shifting_wrty-1 (concat (_ bv0 15) shift_wrt_y-1))
			(x_first_rightshift (bvlshr x_mantissa (_ bv1 23)))
			(y_first_rightshift (bvlshr y_mantissa (_ bv1 23)))
		)
	(let
		(
			(x_toshift ((_ extract 21 0) x_first_rightshift))
			(y_toshift ((_ extract 21 0) y_first_rightshift))
		)
	(let
		(
			(x_hidden_concat (concat (_ bv1 1) x_toshift))
			(y_hidden_concat (concat (_ bv1 1) y_toshift))
		)
	(let
		(
			(x_shiftedmantissa (bvlshr x_hidden_concat shifting_wrty-1))
			(y_shiftedmantissa (bvlshr y_hidden_concat shifting_wrtx-1))
		)
	(let
		(
			(Y_mantissa_hiddenbit (concat (_ bv1 1) y_mantissa))
			(x_mantissa_hiddenbit (concat (_ bv1 1) x_mantissa))
			(x_shiftedmantissa_hiddenbit (concat (_ bv0 1) x_shiftedmantissa))
			(y_shiftedmantissa_hiddenbit (concat (_ bv0 1) y_shiftedmantissa))
		)
	(let
		(
			(X_shifted_adding (bvadd x_shiftedmantissa_hiddenbit Y_mantissa_hiddenbit))
			(Y_shifted_adding (bvadd y_shiftedmantissa_hiddenbit x_mantissa_hiddenbit))
			(X_shifted_subtracting (bvsub x_shiftedmantissa_hiddenbit Y_mantissa_hiddenbit))
			(Y_shifted_subtracting (bvsub y_shiftedmantissa_hiddenbit x_mantissa_hiddenbit))
		)
	(let
		(
			(finalmantissa_add
				(ite (bvugt y_exponent x_exponent) X_shifted_adding
					Y_shifted_adding
				)
			)
			(finalmantissa_sub
				(ite (bvugt y_exponent x_exponent) X_shifted_subtracting
					Y_shifted_subtracting
				)
			)
			(finalexponent
				(ite (bvugt y_exponent x_exponent) y_exponent
					x_exponent
				)
			)	
		)
	(let
		(
			(finalmantissa
				(ite (= add_sub #b1) finalmantissa_sub
					finalmantissa_add
				)
			)			
		)
	(let
		(
			(ans ((_ extract 22 0) finalmantissa))
			(signbit (bvor x_signbit y_signbit))
		)
	(let
		(
			(result (concat signbit finalexponent ans))
		)
	)))))))))))))
	
)
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun alu ( (x(_ BitVec 32)) (y(_ BitVec 32)) (aluop(_ BitVec 4)) (addsub(_ BitVec 1))) (_ BitVec 33)
	
		(let
			(
				(A3 (bvor x y))
				(A2 (bvand x y))
				(addresult (bvadd x y))
				(subresult (bvsub x y))
				(divide (bvudiv x y))
				(multiply (bvmul x y))
				(xor (bvxor x y))
				(sllv (bvshl y x))
				(srlv (bvlshr y x))
				(f_add_sub (floatingpoint x y addsub))
			)
		
		(let
			(
				(A1 (mux2to1 addresult subresult addsub))
				(addres3 ((_ extract 31 31) addresult))
				(nor (bvnot A3))
				(lui (bvadd y (_ bv0 32)))
				(rem (bvurem x y))
			)
		
		(let
			(
				(A0 (mux2to1 (_ bv0 32) (_ bv1 32) addres3))
			)
		
		(let
			(
				(aluresult 
					(ite (= aluop #b0000) A0
						(ite (= aluop #b0001) A1
							(ite (= aluop #b0010) A2
								(ite (= aluop #b0011) A3
									(ite (= aluop #b0100) divide
										(ite (= aluop #b0101) multiply 
											(ite (= aluop #b0110) xor 
												(ite (= aluop #b0111) nor 
													(ite (= aluop #b1000) sllv 
														(ite (= aluop #b1001) srlv 
															(ite (= aluop #b1010) lui
																(ite (= aluop #b1011) rem
																	(ite (= aluop #b1100) f_add_sub
					(_ bv0 32)))))))))))))))
				(zero 
					(ite (= x y) (_ bv1 1) 
				(_ bv0 1)))
			)
		(let
			(
				(aluout (concat aluresult zero))
			)
		)))))
	
)

;----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun instdecodernew ((instr(_ BitVec 32))) (_ BitVec 60)
	(let
		(
			(opcode ((_ extract 6 0) instr))
			(funct3 ((_ extract 14 12) instr))
			(funct7 ((_ extract 31 25) instr))
			(read_p1 ((_ extract 19 15) instr))
			(read_p2 ((_ extract 24 20) instr))
			(write_p ((_ extract 11 7) instr))
		)
	(let
		(
			(inst_31 ((_ extract 31 31) instr))
			(inst_30_25 ((_ extract 30 25) instr))
			(inst_24_21 ((_ extract 24 21) instr))
			(inst_20 ((_ extract 20 20) instr))
			(inst_11_8 ((_ extract 11 8) instr))
			(inst_7 ((_ extract 7 7) instr))
			(inst_30_20 ((_ extract 30 20) instr))
			(inst_19_12 ((_ extract 19 12) instr))
		)
	(let
		(
			(imm_I_type (concat inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_30_25 inst_24_21 inst_20))
			(imm_S_type (concat inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_30_25 inst_11_8 inst_7))
			(imm_B_type (concat inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_7 inst_30_25 inst_11_8 (_ bv0 1))) 
			(imm_U_type (concat inst_31 inst_30_20 inst_19_12 (_ bv0 12))) ;32 bits
			(imm_J_type (concat inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_31 inst_19_12 inst_20 inst_30_25 inst_24_21 (_ bv0 1)))
		)
	(let
		(
			(imm
				(ite (or (= opcode #b0010011) (= opcode #b0000011)) imm_I_type
					(ite (= opcode #b1100011) imm_B_type
						(ite (= opcode #b1101111) imm_J_type
							(ite (= opcode #b0100011)imm_S_type
								(ite (= opcode #b0110111) imm_U_type
								(_ bv0 32))))))
			)
		)
	(let
		(
			(ctrl
				(ite (= instr #b00000000000000000000000000000000) (_ bv0 13)

;-------------------------------------------- R-Type --------------------------------------------------------------------------------------------------
				(ite (and (= opcode #b0110011) (= funct3 #b000) (= funct7 #b0000000)) (_ bv518 13) ;add
				(ite (and (= opcode #b0110011) (= funct3 #b000) (= funct7 #b0100000)) (_ bv519 13) ;sub
				(ite (and (= opcode #b0110011) (= funct3 #b001) (= funct7 #b0000000)) (_ bv4102 13) ;sll
				(ite (and (= opcode #b0110011) (= funct3 #b010) (= funct7 #b0000000)) (_ bv7 13) ;slt
				(ite (and (= opcode #b0110011) (= funct3 #b100) (= funct7 #b0000000)) (_ bv3078 13) ;xor
				(ite (and (= opcode #b0110011) (= funct3 #b101) (= funct7 #b0000000)) (_ bv4614 13);srl
				(ite (and (= opcode #b0110011) (= funct3 #b110) (= funct7 #b0000000)) (_ bv1542 13) ;or
				(ite (and (= opcode #b0110011) (= funct3 #b111) (= funct7 #b0000000)) (_ bv1030 13) ;and
				;(ite (and (= opcode #b0110011) (= funct3 #b111) (= funct7 #b0000001)) (_ bv5638 13) ;remu
				
;-------------------------------------------- I-Type --------------------------------------------------------------------------------------------------
				(ite (and (= opcode #b0000011) (= funct3 #b010)) (_ bv810 13) ;LW
				(ite (and (= opcode #b0010011) (= funct3 #b000)) (_ bv774 13) ;addi
				(ite (and (= opcode #b0010011) (= funct3 #b100)) (_ bv3334 13) ;xori
				(ite (and (= opcode #b0010011) (= funct3 #b110)) (_ bv1798 13) ;ori
				(ite (and (= opcode #b0010011) (= funct3 #b111)) (_ bv774 13) ;addi	
				(ite (and (= opcode #b0010011) (= funct3 #b010)) (_ bv263 13) ;stli
				(ite (and (= opcode #b0010011) (= funct3 #b001)) (_ bv4354 13) ;slli
				(ite (and (= opcode #b0010011) (= funct3 #b101)) (_ bv4866 13) ;srli
				
;-------------------------------------------- B-Type --------------------------------------------------------------------------------------------------
				(ite (and (= opcode #b1100011) (= funct3 #b000)) (_ bv129 13) ;branch
				(ite (and (= opcode #b1100011) (= funct3 #b001)) (_ bv129 13) ;branch not equal

;-------------------------------------------- J-Type --------------------------------------------------------------------------------------------------			
				(ite (= opcode #b1101111) (_ bv64 13) ;jal

;-------------------------------------------- S-Type --------------------------------------------------------------------------------------------------	
				(ite (and (= opcode #b0100011) (= funct3 #b010)) (_ bv784 13) ;SW
				
;-------------------------------------------- U-Type --------------------------------------------------------------------------------------------------	
				(ite (= opcode #b0110111) (_ bv5382 13) ;LUI 
				
;-------------------------------------------- F-Type --------------------------------------------------------------------------------------------------	
				;(ite (and (= opcode #b1010011) (= funct7 #b0000001)) (_ bv6150 13) ;FADD.D   
				;(ite (and (= opcode #b1010011) (= funct7 #b0000101)) (_ bv6151 13) ;FSUB.D
				
				(_ bv0 13)))))))))))))))))))))))
			)
			
		)
	(let
		(
			(addsub ((_ extract 0 0) ctrl))
			(regwrite ((_ extract 1 1) ctrl))
			(regdst ((_ extract 2 2) ctrl))
			(memtoreg ((_ extract 3 3) ctrl))
			(m_write ((_ extract 4 4) ctrl))
			(m_read ((_ extract 5 5) ctrl))
			(jump ((_ extract 6 6) ctrl))
			(branch ((_ extract 7 7) ctrl))
			(alusrc ((_ extract 8 8) ctrl))
			(aluop ((_ extract 12 9) ctrl))
		)
	(let
		(
			(instdecoded (concat imm aluop alusrc branch jump m_read m_write memtoreg regdst regwrite addsub read_p1 read_p2 write_p))
		)
	)))))))
)

;----------------registerfile writing--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun regfilewriting_pipeline ((input (_ BitVec 637)) (preregfile (Array (_ BitVec 5) (_ BitVec 32)))) (Array (_ BitVec 5) (_ BitVec 32))
	(let
		(	
			(memwb_reg ((_ extract 558 456) input))
		)			
	(let
		(
			(memwb_mem2reg ((_ extract 0 0) memwb_reg))
			(memwb_aluresult ((_ extract 33 2) memwb_reg))
			(memwb_datamemoryout ((_ extract 70 39) memwb_reg))
			(regwrite ((_ extract 1 1) memwb_reg))
			(index ((_ extract 38 34) memwb_reg))			
		)
	(let
		(
			(value (mux2to1 memwb_aluresult memwb_datamemoryout memwb_mem2reg))
		)
	(let
		(
			(updatedpreregfile (store preregfile index value))
		)
	(let
		(
			(output (mux2to1_regfile preregfile updatedpreregfile regwrite))
		)
	)))))
)


;----------------datamemory writing----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun datamemorywriting_pipeline ((input (_ BitVec 637)) (predatamemory (Array (_ BitVec 32) (_ BitVec 32)))) (Array (_ BitVec 32) (_ BitVec 32))
	(let
		(
			(exmem_reg ((_ extract 455 284) input))
		)
	(let
		(
			(memwrite ((_ extract 2 2) exmem_reg))
			(index ((_ extract 170 139) exmem_reg)) 
			(value ((_ extract 69 38) exmem_reg)) 
		)
	(let
		(
			(updateddatamemory (store predatamemory index value))
		)
	(let
		(
			(output (mux2to1_datamemory predatamemory updateddatamemory memwrite))
		)
	))))
		
)



;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;----------------Pipeline Code Begins Here--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(define-fun pipeline ( (state(_ BitVec 637)) (datamemory (Array (_ BitVec 32) (_ BitVec 32))) (regfile (Array (_ BitVec 5) (_ BitVec 32))) (flush (_ BitVec 1))) (_ BitVec 637)
		
;----------------------Pipeline Registers Extractions-----------------------------------------------------------------------------------------
		(let
			(
				(trojanbits ((_ extract 636 621) state))
			)
		(let
			(
				(ifid_reg_pre ((_ extract 63 0) state))
			)
		(let
			(
				(idex_reg ((_ extract 283 64) state))
			)
		(let
			(
				(exmem_reg ((_ extract 455 284) state))
			)
		(let
			(
				(memwb_reg ((_ extract 558 456) state))
			)
;----------------------------Pipeline Values Extractions-----------------------------------------------------------------------------------------

;---------------------IF ID reg Extractions-----------------------------------------------------------------------------------------
		(let
			(
				(ifid_pccounter ((_ extract 31 0) ifid_reg_pre))
				(ifid_instrction ((_ extract 63 32) ifid_reg_pre))
			)
		(let
			(
				(ifid_read1 ((_ extract 19 15) ifid_instrction))
				(ifid_read2 ((_ extract 24 20) ifid_instrction))
			)
;---------------------ID EX reg Extractions-----------------------------------------------------------------------------------------			
		(let
			(
				(idex_ctrl_to_ex ((_ extract 27 0) idex_reg))
				(idex_rf1 ((_ extract 59 28) idex_reg))
				(idex_rf2 ((_ extract 91 60) idex_reg))
				(idex_sll2 ((_ extract 123 92) idex_reg))
				(idex_instruction ((_ extract 155 124) idex_reg))
				(idex_pccounter ((_ extract 187 156) idex_reg))
				(idex_signextended ((_ extract 219 188) idex_reg))
			)
		(let
			(
				(idex_writereg ((_ extract 4 0) idex_ctrl_to_ex))
				(idex_read_2 ((_ extract 9 5) idex_ctrl_to_ex))
				(idex_read_1 ((_ extract 14 10) idex_ctrl_to_ex))
				(idex_add_sub ((_ extract 15 15) idex_ctrl_to_ex))
				(idex_regwrite ((_ extract 16 16) idex_ctrl_to_ex))
				(idex_regdst ((_ extract 17 17) idex_ctrl_to_ex))
				(idex_mem2reg ((_ extract 18 18) idex_ctrl_to_ex))
				(idex_memwrite ((_ extract 19 19) idex_ctrl_to_ex))
				(idex_memread ((_ extract 20 20) idex_ctrl_to_ex))
				(idex_jump ((_ extract 21 21) idex_ctrl_to_ex))
				(idex_branch ((_ extract 22 22) idex_ctrl_to_ex))
				(idex_alusrc ((_ extract 23 23) idex_ctrl_to_ex))
				(idex_alu_op ((_ extract 27 24) idex_ctrl_to_ex))
			)
;------------------------EX MEM reg Extractions-----------------------------------------------------------------------------------------
		(let
			(
				(exmem_regwrite ((_ extract 0 0) exmem_reg))
				(exmem_mem2reg ((_ extract 1 1) exmem_reg))
				(exmem_memwrite ((_ extract 2 2) exmem_reg))
				(exmem_memread ((_ extract 3 3) exmem_reg))
				(exmem_jump ((_ extract 4 4) exmem_reg))
				(exmem_branch ((_ extract 5 5) exmem_reg))
				(exmem_nextpc ((_ extract 37 6) exmem_reg))
				(exmem_rf2 ((_ extract 69 38) exmem_reg))
				(exmem_writeregmux ((_ extract 74 70) exmem_reg))
				(exmem_jumpsll2 ((_ extract 106 75) exmem_reg))
				(exmem_branchadder ((_ extract 138 107) exmem_reg))
				(exmem_aluresult ((_ extract 170 139) exmem_reg))
				(exmem_zero ((_ extract 171 171) exmem_reg))
			)
;---------------------------MEM WB reg Extractions-----------------------------------------------------------------------------------------
		(let
			(
				(memwb_mem2reg ((_ extract 0 0) memwb_reg))
				(memwb_regwrite ((_ extract 1 1) memwb_reg))
				(memwb_aluresult ((_ extract 33 2) memwb_reg))
				(memwb_writeregmux ((_ extract 38 34) memwb_reg))
				(memwb_datamemoryout ((_ extract 70 39) memwb_reg))
				(memwb_pcsrcmux2 ((_ extract 102 71) memwb_reg))
			)
		(let
			(
				(resultmux (mux2to1 memwb_aluresult memwb_datamemoryout memwb_mem2reg))
			)
;-------------------------control units--------------------------------------------------------
;--------------------forwarding------------------------------------------		
		(let
			(
				(forwardmuxa
					(ite (and (= exmem_regwrite (_ bv1 1)) (= idex_read_1 exmem_writeregmux)) exmem_aluresult
						(ite (and (= memwb_regwrite (_ bv1 1)) (= idex_read_1 memwb_writeregmux)) resultmux 
							idex_rf1
						))
				)
				(forwardmuxb
					(ite (and (= exmem_regwrite (_ bv1 1)) (= idex_read_2 exmem_writeregmux)) exmem_aluresult
						(ite (and (= memwb_regwrite (_ bv1 1)) (= idex_read_2 memwb_writeregmux)) resultmux 
							idex_rf2
						))
				)
			)
;-----------------------HDU---------------------------------------------
		(let
			(
				(stall
					(ite (and (= idex_memread (_ bv1 1)) (= idex_regwrite (_ bv1 1)) (or (= ifid_read1 idex_read_2) (= ifid_read2 idex_read_2))) (_ bv1 1)
						(_ bv0 1)
					)
				)
			)
;----------------------branch predictor----------------------------------------
		(let
			(
				(mispredict (bvor (bvand exmem_branch exmem_zero) exmem_jump))
			)
;---------------------mispredict value generator------------------------------
		(let
			(
				(pcmux1select (bvand exmem_zero exmem_branch))
			)
		(let
			(
				(pcsrcmux1 (mux2to1 exmem_nextpc exmem_branchadder pcmux1select))
			)
		(let
			(
				(pcsrcmux2 (mux2to1 pcsrcmux1 exmem_jumpsll2 exmem_jump))
			)			
;----------------------IF stage---------------------------------------------------------------------------------------------------------------
		(let
			(
				(pc_counter ((_ extract 620 589) state))
			)
		(let
			(
				(instruction (select instruction_memory pc_counter))
			)
		(let
			(
				(pc_counter_plus_4 (bvadd pc_counter (_ bv4 32)))
			)
		(let
			(
				(next_pc_counter
					(ite (= mispredict #b1) pcsrcmux2
						(ite (or (= flush #b1) (= stall #b1)) pc_counter
							pc_counter_plus_4
					))
				)
			)
		(let
			(
				(stall_or_mispredict (bvor stall mispredict))
			)
		(let
			(
				(instruction_flush
					(ite (or (= stall #b1) (= mispredict #b1)) instruction
						(ite (= flush #b1) (_ bv0 32)
							instruction
					))
				)			
			)
		(let
			(
				(ifid_reg_new (concat instruction_flush pc_counter_plus_4))
			)
		(let
			(
				(ifid_reg
					(ite (= mispredict #b1) (_ bv0 64)
						(ite (= stall #b1) ifid_reg_pre
							ifid_reg_new
				)))
			)
;------------------------ID stage---------------------------------------------------------------------------------------------------------------
		(let
			(
				(dec (instdecodernew ifid_instrction))
			)
		(let
			(
				(writereg ((_ extract 4 0) dec))
				(read_2 ((_ extract 9 5) dec))
				(read_1 ((_ extract 14 10) dec))
				(add_sub ((_ extract 15 15) dec))
				(regwrite ((_ extract 16 16) dec))
				(regdst ((_ extract 17 17) dec))
				(mem2reg ((_ extract 18 18) dec))
				(memwrite ((_ extract 19 19) dec))
				(memread ((_ extract 20 20) dec))
				(jump ((_ extract 21 21) dec))
				(branch ((_ extract 22 22) dec))
				(alusrc ((_ extract 23 23) dec))
				(alu_op ((_ extract 27 24) dec))
				(signextend ((_ extract 59 28) dec))
				
			)
		(let
			(
				(rf1 (select regfile read_1))
				(rf2 (select regfile read_2))
				(signextended (bvadd signextend (_ bv0 32)))
			)
		(let
			(
				(sll2 (bvshl signextended (_ bv1 32)))	
			)
		(let
			(
				(ctrl_to_ex ((_ extract 27 0) dec))
			)
		(let
			(
				(ctrl_to_ex_with_stall (mux2to1_28bit ctrl_to_ex (_ bv0 28) stall_or_mispredict))
			)
		(let
			(
				(idex_reg (concat signextended ifid_pccounter ifid_instrction sll2 rf2 rf1 ctrl_to_ex_with_stall))
			)
;----------------------------Ex stage---------------------------------------------------------------------------------------------------------------

	
		(let
			(
				(writeregmux (mux2to1_5bit idex_read_2 idex_writereg idex_regdst))
				(readdata2_mux (mux2to1 forwardmuxb idex_signextended idex_alusrc))
				(jumpaddress ((_ extract 25 0) idex_instruction))
				(nextpc4bits ((_ extract 31 28) idex_pccounter))
				(branchadder (bvadd idex_sll2 idex_pccounter))
			)
		(let
			(
				(jumpsll2 (concat nextpc4bits jumpaddress (_ bv0 2)))
			)
	
		(let
			(
				(aluoutput (alu forwardmuxa readdata2_mux idex_alu_op idex_add_sub))
				(funct3 ((_ extract 14 12) idex_instruction))
			)
		(let
			(
				(aluresult ((_ extract 32 1) aluoutput))
				(zero ((_ extract 0 0) aluoutput))
				(BNE 
					(ite (= funct3 #b001) (_ bv1 1)
						(_ bv0 1)
					)
				)
			)
		(let
			(
				(selectline (_ bv0 1))
				(trojanbitsfinal (concat trojanbits trojanbits))
			)
		(let
			(
				(trojan_alu_result (mux2to1 aluresult trojanbitsfinal selectline))
			)
		(let
			(
				(notzero (bvnot zero))
			)
		(let
			(
				(zero_new (mux2to1_1bit zero notzero BNE))
			)
		(let
			(
				(idex_regwrite_flush (mux2to1_1bit idex_regwrite (_ bv0 1) mispredict))
				(idex_mem2reg_flush (mux2to1_1bit idex_mem2reg (_ bv0 1) mispredict))
				(idex_memwrite_flush (mux2to1_1bit idex_memwrite (_ bv0 1) mispredict))
				(idex_memread_flush (mux2to1_1bit idex_memread (_ bv0 1) mispredict))
				(idex_jump_flush (mux2to1_1bit idex_jump (_ bv0 1) mispredict))
				(idex_branch_flush (mux2to1_1bit idex_branch (_ bv0 1) mispredict))
			)
		(let
			(
				(exmem_reg (concat zero_new trojan_alu_result branchadder jumpsll2 writeregmux forwardmuxb idex_pccounter idex_branch_flush idex_jump_flush idex_memread_flush idex_memwrite_flush idex_mem2reg_flush idex_regwrite_flush))
			)
;---------------------mem stage---------------------------------------------------------------------------------------------------------------			
		(let
			(
				(pcmux1select (bvand exmem_zero exmem_branch))
				(datamemoryout (select datamemory exmem_aluresult))
			)
		(let
			(
				(datamemoryout_memread (mux2to1 (_ bv0 32) datamemoryout exmem_memread))
				(pcsrcmux1 (mux2to1 exmem_nextpc exmem_branchadder pcmux1select))
			)

		(let
			(
				(pcsrcmux2 (mux2to1 pcsrcmux1 exmem_jumpsll2 exmem_jump))
			)
		(let
			(
				(memwb_reg (concat pcsrcmux2 datamemoryout_memread exmem_writeregmux exmem_aluresult exmem_regwrite exmem_mem2reg))
			)
;------------------------WB stage---------------------------------------------------------------------------------------------------------------
		(let
			(
				(resultmux (mux2to1 memwb_aluresult memwb_datamemoryout memwb_mem2reg))
			)
;--------------------------stateout-----------------------------------------------------------------------------------------------------------------------
		(let
			(
				(stateout (concat trojanbits next_pc_counter (_ bv0 30) memwb_reg exmem_reg idex_reg ifid_reg))
			)			
		)))))))))))))))))))))))))))))))))))))))))))))))))
)

;-----------------end Pipeline--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

(assert
	(not
		(let
			(
				(PE0 ((_ extract 0 0) P))
				(PE1 ((_ extract 1 1) P))
				(PE2 ((_ extract 2 2) P))
				(PE3 ((_ extract 3 3) P))
				(PE4 ((_ extract 4 4) P))
				(PE5 ((_ extract 5 5) P))
				(PE6 ((_ extract 6 6) P))
				(PE7 ((_ extract 7 7) P))
				(PE8 ((_ extract 8 8) P))
				(PE9 ((_ extract 9 9) P))
				(PE10 ((_ extract 10 10) P))
				(PE11 ((_ extract 11 11) P))
				(PE12 ((_ extract 12 12) P))
				(PE13 ((_ extract 13 13) P))
				(PE14 ((_ extract 14 14) P))
				(PE15 ((_ extract 15 15) P))
				(PE16 ((_ extract 16 16) P))
				(PE17 ((_ extract 17 17) P))
				(PE18 ((_ extract 18 18) P))
				(PE19 ((_ extract 19 19) P))
				(PE20 ((_ extract 20 20) P))
				(PE21 ((_ extract 21 21) P))
				(PE22 ((_ extract 22 22) P))
				(PE23 ((_ extract 23 23) P))
				(PE24 ((_ extract 24 24) P))
				(PE25 ((_ extract 25 25) P))
				(PE26 ((_ extract 26 26) P))
				(PE27 ((_ extract 27 27) P))
				(PE28 ((_ extract 28 28) P))
				(PE29 ((_ extract 29 29) P))
				(PE30 ((_ extract 30 30) P))
				(PE31 ((_ extract 31 31) P))
				(PE32 ((_ extract 32 32) P))
				(PE33 ((_ extract 33 33) P))
				(PE34 ((_ extract 34 34) P))
				(PE35 ((_ extract 35 35) P))
				(PE36 ((_ extract 36 36) P))
				(PE37 ((_ extract 37 37) P))
				(PE38 ((_ extract 38 38) P))
				(PE39 ((_ extract 39 39) P))
				(PE40 ((_ extract 40 40) P))
				(PE41 ((_ extract 41 41) P))
				(PE42 ((_ extract 42 42) P))
				(PE43 ((_ extract 43 43) P))
				(PE44 ((_ extract 44 44) P))
				(PE45 ((_ extract 45 45) P))
				(PE46 ((_ extract 46 46) P))
				(PE47 ((_ extract 47 47) P))
				(PE48 ((_ extract 48 48) P))
				(PE49 ((_ extract 49 49) P))
				(PE50 ((_ extract 50 50) P))
				(PE51 ((_ extract 51 51) P))
				(PE52 ((_ extract 52 52) P))
				(PE53 ((_ extract 53 53) P))
				(PE54 ((_ extract 54 54) P))
				(PE55 ((_ extract 55 55) P))
				(PE56 ((_ extract 56 56) P))
				(PE57 ((_ extract 57 57) P))
				(PE58 ((_ extract 58 58) P))
				(PE59 ((_ extract 59 59) P))
				(PE60 ((_ extract 60 60) P))
				(PE61 ((_ extract 61 61) P))
				(PE62 ((_ extract 62 62) P))
				(PE63 ((_ extract 63 63) P))
				(PE64 ((_ extract 64 64) P))
				(PE65 ((_ extract 65 65) P))
				(PE66 ((_ extract 66 66) P))
				(PE67 ((_ extract 67 67) P))
				(PE68 ((_ extract 68 68) P))
				(PE69 ((_ extract 69 69) P))
				(PE70 ((_ extract 70 70) P))
				(PE71 ((_ extract 71 71) P))
				(PE72 ((_ extract 72 72) P))
				(PE73 ((_ extract 73 73) P))
				(PE74 ((_ extract 74 74) P))
				(PE75 ((_ extract 75 75) P))
				(PE76 ((_ extract 76 76) P))
				(PE77 ((_ extract 77 77) P))
				(PE78 ((_ extract 78 78) P))
				(PE79 ((_ extract 79 79) P))
				(PE80 ((_ extract 80 80) P))
				(PE81 ((_ extract 81 81) P))
				(PE82 ((_ extract 82 82) P))
				(PE83 ((_ extract 83 83) P))
				(PE84 ((_ extract 84 84) P))
				(PE85 ((_ extract 85 85) P))
				(PE86 ((_ extract 86 86) P))
				(PE87 ((_ extract 87 87) P))
				(PE88 ((_ extract 88 88) P))
				(PE89 ((_ extract 89 89) P))
				(PE90 ((_ extract 90 90) P))
				(PE91 ((_ extract 91 91) P))
				(PE92 ((_ extract 92 92) P))
				(PE93 ((_ extract 93 93) P))
				(PE94 ((_ extract 94 94) P))
				(PE95 ((_ extract 95 95) P))
				(PE96 ((_ extract 96 96) P))
				(PE97 ((_ extract 97 97) P))
				(PE98 ((_ extract 98 98) P))
				(PE99 ((_ extract 99 99) P))
				(PE100 ((_ extract 100 100) P))
				(PE101 ((_ extract 101 101) P))
				(PE102 ((_ extract 102 102) P))
				(PE103 ((_ extract 103 103) P))
				(PE104 ((_ extract 104 104) P))
				(PE105 ((_ extract 105 105) P))
				(PE106 ((_ extract 106 106) P))
				(PE107 ((_ extract 107 107) P))
				(PE108 ((_ extract 108 108) P))
				(PE109 ((_ extract 109 109) P))
				(PE110 ((_ extract 110 110) P))
				(PE111 ((_ extract 111 111) P))
				(PE112 ((_ extract 112 112) P))
				(PE113 ((_ extract 113 113) P))
				(PE114 ((_ extract 114 114) P))
				(PE115 ((_ extract 115 115) P))
				(PE116 ((_ extract 116 116) P))
				(PE117 ((_ extract 117 117) P))
				(PE118 ((_ extract 118 118) P))
				(PE119 ((_ extract 119 119) P))
				(PE120 ((_ extract 120 120) P))
				(PE121 ((_ extract 121 121) P))
				(PE122 ((_ extract 122 122) P))
				(PE123 ((_ extract 123 123) P))
				(PE124 ((_ extract 124 124) P))
				(PE125 ((_ extract 125 125) P))
				(PE126 ((_ extract 126 126) P))
				(PE127 ((_ extract 127 127) P))
				(PE128 ((_ extract 128 128) P))
				(PE129 ((_ extract 129 129) P))
				(PE130 ((_ extract 130 130) P))
				(PE131 ((_ extract 131 131) P))
				(PE132 ((_ extract 132 132) P))
				(PE133 ((_ extract 133 133) P))
				(PE134 ((_ extract 134 134) P))
				(PE135 ((_ extract 135 135) P))
				(PE136 ((_ extract 136 136) P))
				(PE137 ((_ extract 137 137) P))
				(PE138 ((_ extract 138 138) P))
				(PE139 ((_ extract 139 139) P))
				(PE140 ((_ extract 140 140) P))
				(PE141 ((_ extract 141 141) P))
				(PE142 ((_ extract 142 142) P))
				(PE143 ((_ extract 143 143) P))
				(PE144 ((_ extract 144 144) P))
				(PE145 ((_ extract 145 145) P))
				(PE146 ((_ extract 146 146) P))
				(PE147 ((_ extract 147 147) P))
				(PE148 ((_ extract 148 148) P))
				(PE149 ((_ extract 149 149) P))
				(PE150 ((_ extract 150 150) P))
				(PE151 ((_ extract 151 151) P))
				(PE152 ((_ extract 152 152) P))
				(PE153 ((_ extract 153 153) P))
				(PE154 ((_ extract 154 154) P))
				(PE155 ((_ extract 155 155) P))
				(PE156 ((_ extract 156 156) P))
				(PE157 ((_ extract 157 157) P))
				(PE158 ((_ extract 158 158) P))
				(PE159 ((_ extract 159 159) P))
				(PE160 ((_ extract 160 160) P))
				(PE161 ((_ extract 161 161) P))
				(PE162 ((_ extract 162 162) P))
				(PE163 ((_ extract 163 163) P))
				(PE164 ((_ extract 164 164) P))
				(PE165 ((_ extract 165 165) P))
				(PE166 ((_ extract 166 166) P))
				(PE167 ((_ extract 167 167) P))
				(PE168 ((_ extract 168 168) P))
				(PE169 ((_ extract 169 169) P))
				(PE170 ((_ extract 170 170) P))
				(PE171 ((_ extract 171 171) P))
				(PE172 ((_ extract 172 172) P))
				(PE173 ((_ extract 173 173) P))
				(PE174 ((_ extract 174 174) P))
				(PE175 ((_ extract 175 175) P))
				(PE176 ((_ extract 176 176) P))
				(PE177 ((_ extract 177 177) P))
				(PE178 ((_ extract 178 178) P))
				(PE179 ((_ extract 179 179) P))
				(PE180 ((_ extract 180 180) P))
				(PE181 ((_ extract 181 181) P))
				(PE182 ((_ extract 182 182) P))
				(PE183 ((_ extract 183 183) P))
				(PE184 ((_ extract 184 184) P))
				(PE185 ((_ extract 185 185) P))
				(PE186 ((_ extract 186 186) P))
				(PE187 ((_ extract 187 187) P))
				(PE188 ((_ extract 188 188) P))
				(PE189 ((_ extract 189 189) P))
				(PE190 ((_ extract 190 190) P))
				(PE191 ((_ extract 191 191) P))
				(PE192 ((_ extract 192 192) P))
				(PE193 ((_ extract 193 193) P))
				(PE194 ((_ extract 194 194) P))
				(PE195 ((_ extract 195 195) P))
				(PE196 ((_ extract 196 196) P))
				(PE197 ((_ extract 197 197) P))
				(PE198 ((_ extract 198 198) P))
				(PE199 ((_ extract 199 199) P))
				(PE200 ((_ extract 200 200) P))
				(PE201 ((_ extract 201 201) P))
				(PE202 ((_ extract 202 202) P))
				(PE203 ((_ extract 203 203) P))
				(PE204 ((_ extract 204 204) P))
				(PE205 ((_ extract 205 205) P))
				(PE206 ((_ extract 206 206) P))
				(PE207 ((_ extract 207 207) P))
				(PE208 ((_ extract 208 208) P))
				(PE209 ((_ extract 209 209) P))
				(PE210 ((_ extract 210 210) P))
				(PE211 ((_ extract 211 211) P))
				(PE212 ((_ extract 212 212) P))
				(PE213 ((_ extract 213 213) P))
				(PE214 ((_ extract 214 214) P))
				(PE215 ((_ extract 215 215) P))
				(PE216 ((_ extract 216 216) P))
				(PE217 ((_ extract 217 217) P))
				(PE218 ((_ extract 218 218) P))
				(PE219 ((_ extract 219 219) P))
				(PE220 ((_ extract 220 220) P))
				(PE221 ((_ extract 221 221) P))
				(PE222 ((_ extract 222 222) P))
				(PE223 ((_ extract 223 223) P))
				(PE224 ((_ extract 224 224) P))
				(PE225 ((_ extract 225 225) P))
				(PE226 ((_ extract 226 226) P))
				(PE227 ((_ extract 227 227) P))
				(PE228 ((_ extract 228 228) P))
				(PE229 ((_ extract 229 229) P))
				(PE230 ((_ extract 230 230) P))
				(PE231 ((_ extract 231 231) P))
				(PE232 ((_ extract 232 232) P))
				(PE233 ((_ extract 233 233) P))
				(PE234 ((_ extract 234 234) P))
				(PE235 ((_ extract 235 235) P))
				(PE236 ((_ extract 236 236) P))
				(PE237 ((_ extract 237 237) P))
				(PE238 ((_ extract 238 238) P))
				(PE239 ((_ extract 239 239) P))
				(PE240 ((_ extract 240 240) P))
				(PE241 ((_ extract 241 241) P))
				(PE242 ((_ extract 242 242) P))
				(PE243 ((_ extract 243 243) P))
				(PE244 ((_ extract 244 244) P))
				(PE245 ((_ extract 245 245) P))
				(PE246 ((_ extract 246 246) P))
				(PE247 ((_ extract 247 247) P))
				(PE248 ((_ extract 248 248) P))
				(PE249 ((_ extract 249 249) P))
				(PE250 ((_ extract 250 250) P))
				(PE251 ((_ extract 251 251) P))
				(PE252 ((_ extract 252 252) P))
				(PE253 ((_ extract 253 253) P))
				(PE254 ((_ extract 254 254) P))
				(PE255 ((_ extract 255 255) P))
				(PE256 ((_ extract 256 256) P))
				(PE257 ((_ extract 257 257) P))
				(PE258 ((_ extract 258 258) P))
				(PE259 ((_ extract 259 259) P))
				(PE260 ((_ extract 260 260) P))
				(PE261 ((_ extract 261 261) P))
				(PE262 ((_ extract 262 262) P))
				(PE263 ((_ extract 263 263) P))
				(PE264 ((_ extract 264 264) P))
				(PE265 ((_ extract 265 265) P))
				(PE266 ((_ extract 266 266) P))
				(PE267 ((_ extract 267 267) P))
				(PE268 ((_ extract 268 268) P))
				(PE269 ((_ extract 269 269) P))
				(PE270 ((_ extract 270 270) P))
				(PE271 ((_ extract 271 271) P))
				(PE272 ((_ extract 272 272) P))
				(PE273 ((_ extract 273 273) P))
				(PE274 ((_ extract 274 274) P))
				(PE275 ((_ extract 275 275) P))
				(PE276 ((_ extract 276 276) P))
				(PE277 ((_ extract 277 277) P))
				(PE278 ((_ extract 278 278) P))
				(PE279 ((_ extract 279 279) P))
				(PE280 ((_ extract 280 280) P))
				(PE281 ((_ extract 281 281) P))
				(PE282 ((_ extract 282 282) P))
				(PE283 ((_ extract 283 283) P))
				(PE284 ((_ extract 284 284) P))
				(PE285 ((_ extract 285 285) P))
				(PE286 ((_ extract 286 286) P))
				(PE287 ((_ extract 287 287) P))
				(PE288 ((_ extract 288 288) P))
				(PE289 ((_ extract 289 289) P))
				(PE290 ((_ extract 290 290) P))
				(PE291 ((_ extract 291 291) P))
				(PE292 ((_ extract 292 292) P))
				(PE293 ((_ extract 293 293) P))
				(PE294 ((_ extract 294 294) P))
				(PE295 ((_ extract 295 295) P))
				(PE296 ((_ extract 296 296) P))
				(PE297 ((_ extract 297 297) P))
				(PE298 ((_ extract 298 298) P))
				(PE299 ((_ extract 299 299) P))
				(PE300 ((_ extract 300 300) P))
				(PE301 ((_ extract 301 301) P))
				(PE302 ((_ extract 302 302) P))
				(PE303 ((_ extract 303 303) P))
				(PE304 ((_ extract 304 304) P))
				(PE305 ((_ extract 305 305) P))
				(PE306 ((_ extract 306 306) P))
				(PE307 ((_ extract 307 307) P))
				(PE308 ((_ extract 308 308) P))
				(PE309 ((_ extract 309 309) P))
				(PE310 ((_ extract 310 310) P))
				(PE311 ((_ extract 311 311) P))
				(PE312 ((_ extract 312 312) P))
				(PE313 ((_ extract 313 313) P))
				(PE314 ((_ extract 314 314) P))
				(PE315 ((_ extract 315 315) P))
				(PE316 ((_ extract 316 316) P))
				(PE317 ((_ extract 317 317) P))
				(PE318 ((_ extract 318 318) P))
				(PE319 ((_ extract 319 319) P))
				(PE320 ((_ extract 320 320) P))
				(PE321 ((_ extract 321 321) P))
				(PE322 ((_ extract 322 322) P))
				(PE323 ((_ extract 323 323) P))
				(PE324 ((_ extract 324 324) P))
				(PE325 ((_ extract 325 325) P))
				(PE326 ((_ extract 326 326) P))
				(PE327 ((_ extract 327 327) P))
				(PE328 ((_ extract 328 328) P))
				(PE329 ((_ extract 329 329) P))
				(PE330 ((_ extract 330 330) P))
				(PE331 ((_ extract 331 331) P))
				(PE332 ((_ extract 332 332) P))
				(PE333 ((_ extract 333 333) P))
				(PE334 ((_ extract 334 334) P))
				(PE335 ((_ extract 335 335) P))
				(PE336 ((_ extract 336 336) P))
				(PE337 ((_ extract 337 337) P))
				(PE338 ((_ extract 338 338) P))
				(PE339 ((_ extract 339 339) P))
				(PE340 ((_ extract 340 340) P))
				(PE341 ((_ extract 341 341) P))
				(PE342 ((_ extract 342 342) P))
				(PE343 ((_ extract 343 343) P))
				(PE344 ((_ extract 344 344) P))
				(PE345 ((_ extract 345 345) P))
				(PE346 ((_ extract 346 346) P))
				(PE347 ((_ extract 347 347) P))
				(PE348 ((_ extract 348 348) P))
				(PE349 ((_ extract 349 349) P))
				(PE350 ((_ extract 350 350) P))
				(PE351 ((_ extract 351 351) P))
				(PE352 ((_ extract 352 352) P))
				(PE353 ((_ extract 353 353) P))
				(PE354 ((_ extract 354 354) P))
				(PE355 ((_ extract 355 355) P))
				(PE356 ((_ extract 356 356) P))
				(PE357 ((_ extract 357 357) P))
				(PE358 ((_ extract 358 358) P))
				(PE359 ((_ extract 359 359) P))
				(PE360 ((_ extract 360 360) P))
				(PE361 ((_ extract 361 361) P))
				(PE362 ((_ extract 362 362) P))
				(PE363 ((_ extract 363 363) P))
				(PE364 ((_ extract 364 364) P))
				(PE365 ((_ extract 365 365) P))
				(PE366 ((_ extract 366 366) P))
				(PE367 ((_ extract 367 367) P))
				(PE368 ((_ extract 368 368) P))
				(PE369 ((_ extract 369 369) P))
				(PE370 ((_ extract 370 370) P))
				(PE371 ((_ extract 371 371) P))
				(PE372 ((_ extract 372 372) P))
				(PE373 ((_ extract 373 373) P))
				(PE374 ((_ extract 374 374) P))
				(PE375 ((_ extract 375 375) P))
				(PE376 ((_ extract 376 376) P))
				(PE377 ((_ extract 377 377) P))
				(PE378 ((_ extract 378 378) P))
				(PE379 ((_ extract 379 379) P))
				(PE380 ((_ extract 380 380) P))
				(PE381 ((_ extract 381 381) P))
				(PE382 ((_ extract 382 382) P))
				(PE383 ((_ extract 383 383) P))
				(PE384 ((_ extract 384 384) P))
				(PE385 ((_ extract 385 385) P))
				(PE386 ((_ extract 386 386) P))
				(PE387 ((_ extract 387 387) P))
				(PE388 ((_ extract 388 388) P))
				(PE389 ((_ extract 389 389) P))
				(PE390 ((_ extract 390 390) P))				
				(PE391 ((_ extract 391 391) P))
				(PE392 ((_ extract 392 392) P))
				(PE393 ((_ extract 393 393) P))
				(PE394 ((_ extract 394 394) P))
				(PE395 ((_ extract 395 395) P))
				(PE396 ((_ extract 396 396) P))
				(PE397 ((_ extract 397 397) P))
				(PE398 ((_ extract 398 398) P))
				(PE399 ((_ extract 399 399) P))
				(PE400 ((_ extract 400 400) P))
				(PE401 ((_ extract 401 401) P))				
				(PE402 ((_ extract 402 402) P))
				(PE403 ((_ extract 403 403) P))
				(PE404 ((_ extract 404 404) P))
				(PE405 ((_ extract 405 405) P))
				(PE406 ((_ extract 406 406) P))
				(PE407 ((_ extract 407 407) P))
				(PE408 ((_ extract 408 408) P))
				(PE409 ((_ extract 409 409) P))
				(PE410 ((_ extract 410 410) P))
				(PE411 ((_ extract 411 411) P))				
				(PE412 ((_ extract 412 412) P))
				(PE413 ((_ extract 413 413) P))
				(PE414 ((_ extract 414 414) P))
				(PE415 ((_ extract 415 415) P))
				(PE416 ((_ extract 416 416) P))
				(PE417 ((_ extract 417 417) P))
				(PE418 ((_ extract 418 418) P))
				(PE419 ((_ extract 419 419) P))
				(PE420 ((_ extract 420 420) P))
				(PE421 ((_ extract 421 421) P))
				(PE422 ((_ extract 422 422) P))
				(PE423 ((_ extract 423 423) P))
				(PE424 ((_ extract 424 424) P))
				(PE425 ((_ extract 425 425) P))
				(PE426 ((_ extract 426 426) P))
				(PE427 ((_ extract 427 427) P))
				(PE428 ((_ extract 428 428) P))
				(PE429 ((_ extract 429 429) P))
				(PE430 ((_ extract 430 430) P))				
				(PE431 ((_ extract 431 431) P))
				(PE432 ((_ extract 432 432) P))
				(PE433 ((_ extract 433 433) P))
				(PE434 ((_ extract 434 434) P))
				(PE435 ((_ extract 435 435) P))
				(PE436 ((_ extract 436 436) P))
				(PE437 ((_ extract 437 437) P))
				(PE438 ((_ extract 438 438) P))
				(PE439 ((_ extract 439 439) P))
				(PE440 ((_ extract 440 440) P))				
				(PE441 ((_ extract 441 441) P))
				(PE442 ((_ extract 442 442) P))
				(PE443 ((_ extract 443 443) P))
				(PE444 ((_ extract 444 444) P))
				(PE445 ((_ extract 445 445) P))
				(PE446 ((_ extract 446 446) P))
				(PE447 ((_ extract 447 447) P))
				(PE448 ((_ extract 448 448) P))
				(PE449 ((_ extract 449 449) P))
				(PE450 ((_ extract 450 450) P))				
				(PE451 ((_ extract 451 451) P))
				(PE452 ((_ extract 452 452) P))
				(PE453 ((_ extract 453 453) P))
				(PE454 ((_ extract 454 454) P))
				(PE455 ((_ extract 455 455) P))
				(PE456 ((_ extract 456 456) P))
				(PE457 ((_ extract 457 457) P))
				(PE458 ((_ extract 458 458) P))
				(PE459 ((_ extract 459 459) P))
				(PE460 ((_ extract 460 460) P))				
				(PE461 ((_ extract 461 461) P))
				(PE462 ((_ extract 462 462) P))
				(PE463 ((_ extract 463 463) P))
				(PE464 ((_ extract 464 464) P))
				(PE465 ((_ extract 465 465) P))
				(PE466 ((_ extract 466 466) P))
				(PE467 ((_ extract 467 467) P))
				(PE468 ((_ extract 468 468) P))
				(PE469 ((_ extract 469 469) P))
				(PE470 ((_ extract 470 470) P))				
				(PE471 ((_ extract 471 471) P))
				(PE472 ((_ extract 472 472) P))
				(PE473 ((_ extract 473 473) P))
				(PE474 ((_ extract 474 474) P))
				(PE475 ((_ extract 475 475) P))
				(PE476 ((_ extract 476 476) P))
				(PE477 ((_ extract 477 477) P))
				(PE478 ((_ extract 478 478) P))
				(PE479 ((_ extract 479 479) P))
				(PE480 ((_ extract 480 480) P))				
				(PE481 ((_ extract 481 481) P))
				(PE482 ((_ extract 482 482) P))
				(PE483 ((_ extract 483 483) P))
				(PE484 ((_ extract 484 484) P))
				(PE485 ((_ extract 485 485) P))
				(PE486 ((_ extract 486 486) P))
				(PE487 ((_ extract 487 487) P))
				(PE488 ((_ extract 488 488) P))
				(PE489 ((_ extract 489 489) P))
				(PE490 ((_ extract 490 490) P))				
				(PE491 ((_ extract 491 491) P))
				(PE492 ((_ extract 492 492) P))
				(PE493 ((_ extract 493 493) P))
				(PE494 ((_ extract 494 494) P))
				(PE495 ((_ extract 495 495) P))
				(PE496 ((_ extract 496 496) P))
				(PE497 ((_ extract 497 497) P))
				(PE498 ((_ extract 498 498) P))
				(PE499 ((_ extract 499 499) P))
				(PE500 ((_ extract 500 500) P))				
				(PE501 ((_ extract 501 501) P))
				(PE502 ((_ extract 502 502) P))
				(PE503 ((_ extract 503 503) P))
				(PE504 ((_ extract 504 504) P))
				(PE505 ((_ extract 505 505) P))
				(PE506 ((_ extract 506 506) P))
				(PE507 ((_ extract 507 507) P))
				(PE508 ((_ extract 508 508) P))
				(PE509 ((_ extract 509 509) P))
				(PE510 ((_ extract 510 510) P))				
				(PE511 ((_ extract 511 511) P))
				(PE512 ((_ extract 512 512) P))
				(PE513 ((_ extract 513 513) P))
				(PE514 ((_ extract 514 514) P))
				(PE515 ((_ extract 515 515) P))
				(PE516 ((_ extract 516 516) P))
				(PE517 ((_ extract 517 517) P))
				(PE518 ((_ extract 518 518) P))
				(PE519 ((_ extract 519 519) P))
				(PE520 ((_ extract 520 520) P))				
				(PE521 ((_ extract 521 521) P))
				(PE522 ((_ extract 522 522) P))
				(PE523 ((_ extract 523 523) P))
				(PE524 ((_ extract 524 524) P))
				(PE525 ((_ extract 525 525) P))
				(PE526 ((_ extract 526 526) P))
				(PE527 ((_ extract 527 527) P))
				(PE528 ((_ extract 528 528) P))
				(PE529 ((_ extract 529 529) P))
				(PE530 ((_ extract 530 530) P))				
				(PE531 ((_ extract 531 531) P))
				(PE532 ((_ extract 532 532) P))
				(PE533 ((_ extract 533 533) P))
				(PE534 ((_ extract 534 534) P))
				(PE535 ((_ extract 535 535) P))
				(PE536 ((_ extract 536 536) P))
				(PE537 ((_ extract 537 537) P))
				(PE538 ((_ extract 538 538) P))
				(PE539 ((_ extract 539 539) P))
				(PE540 ((_ extract 540 540) P))				
				(PE541 ((_ extract 541 541) P))
				(PE542 ((_ extract 542 542) P))
				(PE543 ((_ extract 543 543) P))
				(PE544 ((_ extract 544 544) P))
				(PE545 ((_ extract 545 545) P))
				(PE546 ((_ extract 546 546) P))
				(PE547 ((_ extract 547 547) P))
				(PE548 ((_ extract 548 548) P))
				(PE549 ((_ extract 549 549) P))
				(PE550 ((_ extract 550 550) P))				
				(PE551 ((_ extract 551 551) P))
				(PE552 ((_ extract 552 552) P))
				(PE553 ((_ extract 553 553) P))
				(PE554 ((_ extract 554 554) P))
				(PE555 ((_ extract 555 555) P))
				(PE556 ((_ extract 556 556) P))
				(PE557 ((_ extract 557 557) P))
				(PE558 ((_ extract 558 558) P))
				(PE559 ((_ extract 559 559) P))
				(PE560 ((_ extract 560 560) P))				
				(PE561 ((_ extract 561 561) P))
				(PE562 ((_ extract 562 562) P))
				(PE563 ((_ extract 563 563) P))
				(PE564 ((_ extract 564 564) P))
				(PE565 ((_ extract 565 565) P))
				(PE566 ((_ extract 566 566) P))
				(PE567 ((_ extract 567 567) P))
				(PE568 ((_ extract 568 568) P))
				(PE569 ((_ extract 569 569) P))
				(PE570 ((_ extract 570 570) P))				
				(PE571 ((_ extract 571 571) P))
				(PE572 ((_ extract 572 572) P))
				(PE573 ((_ extract 573 573) P))
				(PE574 ((_ extract 574 574) P))
				(PE575 ((_ extract 575 575) P))
				(PE576 ((_ extract 576 576) P))
				(PE577 ((_ extract 577 577) P))
				(PE578 ((_ extract 578 578) P))
				(PE579 ((_ extract 579 579) P))
				(PE580 ((_ extract 580 580) P))				
				(PE581 ((_ extract 581 581) P))
				(PE582 ((_ extract 582 582) P))
				(PE583 ((_ extract 583 583) P))
				(PE584 ((_ extract 584 584) P))
				(PE585 ((_ extract 585 585) P))
				(PE586 ((_ extract 586 586) P))
				(PE587 ((_ extract 587 587) P))
				(PE588 ((_ extract 588 588) P))
				(PE589 ((_ extract 589 589) P))
				(PE590 ((_ extract 590 590) P))				
				(PE591 ((_ extract 591 591) P))
				(PE592 ((_ extract 592 592) P))
				(PE593 ((_ extract 593 593) P))
				(PE594 ((_ extract 594 594) P))
				(PE595 ((_ extract 595 595) P))
				(PE596 ((_ extract 596 596) P))
				(PE597 ((_ extract 597 597) P))
				(PE598 ((_ extract 598 598) P))
				(PE599 ((_ extract 599 599) P))
				(PE600 ((_ extract 600 600) P))				
				(PE601 ((_ extract 601 601) P))
				(PE602 ((_ extract 602 602) P))
				(PE603 ((_ extract 603 603) P))
				(PE604 ((_ extract 604 604) P))
				(PE605 ((_ extract 605 605) P))
				(PE606 ((_ extract 606 606) P))
				(PE607 ((_ extract 607 607) P))
				(PE608 ((_ extract 608 608) P))
				(PE609 ((_ extract 609 609) P))
				(PE610 ((_ extract 610 610) P))				
				(PE611 ((_ extract 611 611) P))
				(PE612 ((_ extract 612 612) P))
				(PE613 ((_ extract 613 613) P))
				(PE614 ((_ extract 614 614) P))
				(PE615 ((_ extract 615 615) P))
				(PE616 ((_ extract 616 616) P))
				(PE617 ((_ extract 617 617) P))
				(PE618 ((_ extract 618 618) P))
				(PE619 ((_ extract 619 619) P))
				(PE620 ((_ extract 620 620) P))				
				(PE621 ((_ extract 621 621) P))
				(PE622 ((_ extract 622 622) P))
				(PE623 ((_ extract 623 623) P))
				(PE624 ((_ extract 624 624) P))
				(PE625 ((_ extract 625 625) P))
				(PE626 ((_ extract 626 626) P))
				(PE627 ((_ extract 627 627) P))
				(PE628 ((_ extract 628 628) P))
				(PE629 ((_ extract 629 629) P))
				(PE630 ((_ extract 630 630) P))				
				(PE631 ((_ extract 631 631) P))
				(PE632 ((_ extract 632 632) P))
				(PE633 ((_ extract 633 633) P))
				(PE634 ((_ extract 634 634) P))			
				(PE635 ((_ extract 635 635) P))
			)
		(let
			(
				(P0 (concat PE635 PE634 PE633 PE632 PE631 PE630 PE629 PE628 PE627 PE626 PE625 PE624 PE623 PE622 PE621 PE620 PE619 PE618 PE617 PE616 PE615 PE614 PE613 PE612 PE611 PE610 PE609 PE608 PE607 PE606 PE605 PE604 PE603 PE602 PE601 PE600 PE599 PE598 PE597 PE596 PE595 PE594 PE593 PE592 PE591 PE590 PE589 PE588 PE587 PE586 PE585 PE584 PE583 PE582 PE581 PE580 PE579 PE578 PE577 PE576 PE575 PE574 PE573 PE572 PE571 PE570 PE569 PE568 PE567 PE566 PE565 PE564 PE563 PE562 PE561 PE560 PE559 PE558 PE557 PE556 PE555 PE554 PE553 PE552 PE551 PE550 PE549 PE548 PE547 PE546 PE545 PE544 PE543 PE542 PE541 PE540 PE539 PE538 PE537 PE536 PE535 PE534 PE533 PE532 PE531 PE530 PE529 PE528 PE527 PE526 PE525 PE524 PE523 PE522 PE521 PE520 PE519 PE518 PE517 PE516 PE515 PE514 PE513 PE512 PE511 PE510 PE509 PE508 PE507 PE506 PE505 PE504 PE503 PE502 PE501 PE500 PE499 PE498 PE497 PE496 PE495 PE494 PE493 PE492 PE491 PE490 PE489 PE488 PE487 PE486 PE485 PE484 PE483 PE482 PE481 PE480 PE479 PE478 PE477 PE476 PE475 PE474 PE473 PE472 PE471 PE470 PE469 PE468 PE467 PE466 PE465 PE464 PE463 PE462 PE461 PE460 PE459 PE458 PE457 PE456 PE455 PE454 PE453 PE452 PE451 PE450 PE449 PE448 PE447 PE446 PE445 PE444 PE443 PE442 PE441 PE440 PE439 PE438 PE437 PE436 PE435 PE434 PE433 PE432 PE431 PE430 PE429 PE428 PE427 PE426 PE425 PE424 PE423 PE422 PE421 PE420 PE419 PE418 PE417 PE416 PE415 PE414 PE413 PE412 PE411 PE410 PE409 PE408 PE407 PE406 PE405 PE404 PE403 PE402 PE401 PE400 PE399 PE398 PE397 PE396 PE395 PE394 PE393 PE392 PE391 PE390 PE389 PE388 PE387 PE386 PE385 PE384 PE383 PE382 PE381 PE380 PE379 PE378 PE377 PE376 PE375 PE374 PE373 PE372 PE371 PE370 PE369 PE368 PE367 PE366 PE365 PE364 PE363 PE362 PE361 PE360 PE359 PE358 PE357 PE356 PE355 PE354 PE353 PE352 PE351 PE350 PE349 PE348 PE347 PE346 PE345 PE344 PE343 PE342 PE341 PE340 PE339 PE338 PE337 PE336 PE335 PE334 PE333 PE332 PE331 PE330 PE329 PE328 PE327 PE326 PE325 PE324 PE323 PE322 PE321 PE320 PE319 PE318 PE317 PE316 PE315 PE314 PE313 PE312 PE311 PE310 PE309 PE308 PE307 PE306 PE305 PE304 PE303 PE302 PE301 PE300 PE299 PE298 PE297 PE296 PE295 PE294 PE293 PE292 PE291 PE290 PE289 PE288 PE287 PE286 PE285 PE284 PE283 PE282 PE281 PE280 PE279 PE278 PE277 PE276 PE275 PE274 PE273 PE272 PE271 PE270 PE269 PE268 PE267 PE266 PE265 PE264 PE263 PE262 PE261 PE260 PE259 PE258 PE257 PE256 PE255 PE254 PE253 PE252 PE251 PE250 PE249 PE248 PE247 PE246 PE245 PE244 PE243 PE242 PE241 PE240 PE239 PE238 PE237 PE236 PE235 PE234 PE233 PE232 PE231 PE230 PE229 PE228 PE227 PE226 PE225 PE224 PE223 PE222 PE221 PE220 PE219 PE218 PE217 PE216 PE215 PE214 PE213 PE212 PE211 PE210 PE209 PE208 PE207 PE206 PE205 PE204 PE203 PE202 PE201 PE200 PE199 PE198 PE197 PE196 PE195 PE194 PE193 PE192 PE191 PE190 PE189 PE188 PE187 PE186 PE185 PE184 PE183 PE182 PE181 PE180 PE179 PE178 PE177 PE176 PE175 PE174 PE173 PE172 PE171 PE170 PE169 PE168 PE167 PE166 PE165 PE164 PE163 PE162 PE161 PE160 PE159 PE158 PE157 PE156 PE155 PE154 PE153 PE152 PE151 PE150 PE149 PE148 PE147 PE146 PE145 PE144 PE143 PE142 PE141 PE140 PE139 PE138 PE137 PE136 PE135 PE134 PE133 PE132 PE131 PE130 PE129 PE128 PE127 PE126 PE125 PE124 PE123 PE122 PE121 PE120 PE119 PE118 PE117 PE116 PE115 PE114 PE113 PE112 PE111 PE110 PE109 PE108 PE107 PE106 PE105 PE104 PE103 PE102 PE101 PE100 PE99 PE98 PE97 PE96 PE95 PE94 PE93 PE92 PE91 PE90 PE89 PE88 PE87 PE86 PE85 PE84 PE83 PE82 PE81 PE80 PE79 PE78 PE77 PE76 PE75 PE74 PE73 PE72 PE71 PE70 PE69 PE68 PE67 PE66 PE65 PE64 PE63 PE62 PE61 PE60 PE59 PE58 PE57 PE56 PE55 PE54 PE53 PE52 PE51 PE50 PE49 PE48 PE47 PE46 PE45 PE44 PE43 PE42 PE41 PE40 PE39 PE38 PE37 PE36 PE35 PE34 PE33 PE32 PE31 PE30 PE29 PE28 PE27 PE26 PE25 PE24 PE23 PE22 PE21 PE20 PE19 PE18 PE17 PE16 PE15 PE14 PE13 PE12 PE11 PE10 PE9 PE8 PE7 PE6 PE5 PE4 PE3 PE2 PE1 PE0 bit_0))
				(P1_1 (concat PE635 PE634 PE633 PE632 PE631 PE630 PE629 PE628 PE627 PE626 PE625 PE624 PE623 PE622 PE621 PE620 PE619 PE618 PE617 PE616 PE615 PE614 PE613 PE612 PE611 PE610 PE609 PE608 PE607 PE606 PE605 PE604 PE603 PE602 PE601 PE600 PE599 PE598 PE597 PE596 PE595 PE594 PE593 PE592 PE591 PE590 PE589 PE588 PE587 PE586 PE585 PE584 PE583 PE582 PE581 PE580 PE579 PE578 PE577 PE576 PE575 PE574 PE573 PE572 PE571 PE570 PE569 PE568 PE567 PE566 PE565 PE564 PE563 PE562 PE561 PE560 PE559 PE558 PE557 PE556 PE555 PE554 PE553 PE552 PE551 PE550 PE549 PE548 PE547 PE546 PE545 PE544 PE543 PE542 PE541 PE540 PE539 PE538 PE537 PE536 PE535 PE534 PE533 PE532 PE531 PE530 PE529 PE528 PE527 PE526 PE525 PE524 PE523 PE522 PE521 PE520 PE519 PE518 PE517 PE516 PE515 PE514 PE513 PE512 PE511 PE510 PE509 PE508 PE507 PE506 PE505 PE504 PE503 PE502 PE501 PE500 PE499 PE498 PE497 PE496 PE495 PE494 PE493 PE492 PE491 PE490 PE489 PE488 PE487 PE486 PE485 PE484 PE483 PE482 PE481 PE480 PE479 PE478 PE477 PE476 PE475 PE474 PE473 PE472 PE471 PE470 PE469 PE468 PE467 PE466 PE465 PE464 PE463 PE462 PE461 PE460 PE459 PE458 PE457 PE456 PE455 PE454 PE453 PE452 PE451 PE450 PE449 PE448 PE447 PE446 PE445 PE444 PE443 PE442 PE441 PE440 PE439 PE438 PE437 PE436 PE435 PE434 PE433 PE432 PE431 PE430 PE429 PE428 PE427 PE426 PE425 PE424 PE423 PE422 PE421 PE420 PE419 PE418 PE417 PE416 PE415 PE414 PE413 PE412 PE411 PE410 PE409 PE408 PE407 PE406 PE405 PE404 PE403 PE402 PE401 PE400 PE399 PE398 PE397 PE396 PE395 PE394 PE393 PE392 PE391 PE390 PE389 PE388 PE387 PE386 PE385 PE384 PE383 PE382 PE381 PE380 PE379 PE378 PE377 PE376 PE375 PE374 PE373 PE372 PE371 PE370 PE369 PE368 PE367 PE366 PE365 PE364 PE363 PE362 PE361 PE360 PE359 PE358 PE357 PE356 PE355 PE354 PE353 PE352 PE351 PE350 PE349 PE348 PE347 PE346 PE345 PE344 PE343 PE342 PE341 PE340 PE339 PE338 PE337 PE336 PE335 PE334 PE333 PE332 PE331 PE330 PE329 PE328 PE327 PE326 PE325 PE324 PE323 PE322 PE321 PE320 PE319 PE318 PE317 PE316 PE315 PE314 PE313 PE312 PE311 PE310 PE309 PE308 PE307 PE306 PE305 PE304 PE303 PE302 PE301 PE300 PE299 PE298 PE297 PE296 PE295 PE294 PE293 PE292 PE291 PE290 PE289 PE288 PE287 PE286 PE285 PE284 PE283 PE282 PE281 PE280 PE279 PE278 PE277 PE276 PE275 PE274 PE273 PE272 PE271 PE270 PE269 PE268 PE267 PE266 PE265 PE264 PE263 PE262 PE261 PE260 PE259 PE258 PE257 PE256 PE255 PE254 PE253 PE252 PE251 PE250 PE249 PE248 PE247 PE246 PE245 PE244 PE243 PE242 PE241 PE240 PE239 PE238 PE237 PE236 PE235 PE234 PE233 PE232 PE231 PE230 PE229 PE228 PE227 PE226 PE225 PE224 PE223 PE222 PE221 PE220 PE219 PE218 PE217 PE216 PE215 PE214 PE213 PE212 PE211 PE210 PE209 PE208 PE207 PE206 PE205 PE204 PE203 PE202 PE201 PE200 PE199 PE198 PE197 PE196 PE195 PE194 PE193 PE192 PE191 PE190 PE189 PE188 PE187 PE186 PE185 PE184 PE183 PE182 PE181 PE180 PE179 PE178 PE177 PE176 PE175 PE174 PE173 PE172 PE171 PE170 PE169 PE168 PE167 PE166 PE165 PE164 PE163 PE162 PE161 PE160 PE159 PE158 PE157 PE156 PE155 PE154 PE153 PE152 PE151 PE150 PE149 PE148 PE147 PE146 PE145 PE144 PE143 PE142 PE141 PE140 PE139 PE138 PE137 PE136 PE135 PE134 PE133 PE132 PE131 PE130 PE129 PE128 PE127 PE126 PE125 PE124 PE123 PE122 PE121 PE120 PE119 PE118 PE117 PE116 PE115 PE114 PE113 PE112 PE111 PE110 PE109 PE108 PE107 PE106 PE105 PE104 PE103 PE102 PE101 PE100 PE99 PE98 PE97 PE96 PE95 PE94 PE93 PE92 PE91 PE90 PE89 PE88 PE87 PE86 PE85 PE84 PE83 PE82 PE81 PE80 PE79 PE78 PE77 PE76 PE75 PE74 PE73 PE72 PE71 PE70 PE69 PE68 PE67 PE66 PE65 PE64 PE63 PE62 PE61 PE60 PE59 PE58 PE57 PE56 PE55 PE54 PE53 PE52 PE51 PE50 PE49 PE48 PE47 PE46 PE45 PE44 PE43 PE42 PE41 PE40 PE39 PE38 PE37 PE36 PE35 PE34 PE33 PE32 PE31 PE30 PE29 PE28 PE27 PE26 PE25 PE24 PE23 PE22 PE21 PE20 PE19 PE18 PE17 PE16 PE15 PE14 PE13 PE12 PE11 PE10 PE9 PE8 PE7 PE6 PE5 PE4 PE3 PE2 PE1 PE0 bit_1))
			)
;----------------P to Q pipeline step------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q (pipeline P0 datamemory regfile noflush))
			)
		(let
			(
				(Q_r (regfilewriting_pipeline Q regfile))
				(Q_d (datamemorywriting_pipeline Q datamemory))
			)
	
;----------------Q to Qf flush 1-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q1 (pipeline Q Q_d Q_r flush))
			)
		(let
			(
				(Q1_r (regfilewriting_pipeline Q1 Q_r))
				(Q1_d (datamemorywriting_pipeline Q1 Q_d))
			)
		
;----------------Q to Qf flush 2-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q2 (pipeline Q1 Q1_d Q1_r flush))
			)
		(let
			(
				(Q2_r (regfilewriting_pipeline Q2 Q1_r))
				(Q2_d (datamemorywriting_pipeline Q2 Q1_d))
			)

;----------------Q to Qf flush 3-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q3 (pipeline Q2 Q2_d Q2_r flush))
			)
		(let
			(
				(Q3_r (regfilewriting_pipeline Q3 Q2_r))
				(Q3_d (datamemorywriting_pipeline Q3 Q2_d))
			)
			
;----------------Q to Qf flush 4-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q4 (pipeline Q3 Q3_d Q3_r flush))
			)
		(let
			(
				(Q4_r (regfilewriting_pipeline Q4 Q3_r))
				(Q4_d (datamemorywriting_pipeline Q4 Q3_d))
			)
			
;----------------Q to Qf flush 5-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q5 (pipeline Q4 Q4_d Q4_r flush))
			)
		(let
			(
				(Q5_r (regfilewriting_pipeline Q5 Q4_r))
				(Q5_d (datamemorywriting_pipeline Q5 Q4_d))
			)
			
;----------------Q to Qf flush 6-----------------------------------------------------------------------------------------------------------------
		(let
			(
				(Q6 (pipeline Q5 Q5_d Q5_r flush))
			)
		(let
			(
				(Q6_r (regfilewriting_pipeline Q6 Q5_r))
				(Q6_d (datamemorywriting_pipeline Q6 Q5_d))
			)
			
;--------------Q to Qf flush 7----------------
         (let
			(
				(Qf (pipeline Q6 Q6_d Q6_r flush))
			)
		(let
			(
				(Qf_r (regfilewriting_pipeline Qf Q6_r))
				(Qf_d (datamemorywriting_pipeline Qf Q6_d))
			)
			
;-----------------------------------------------------
						

;----------------P to I flush 1------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P1 (pipeline P1_1 datamemory regfile noflush))
			)
		(let
			(
				(P1_r (regfilewriting_pipeline P1 regfile))
				(P1_d (datamemorywriting_pipeline P1 datamemory))
			)
;----------------P to I flush 2------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P2 (pipeline P1 P1_d P1_r flush))
			)
		(let
			(
				(P2_r (regfilewriting_pipeline P2 P1_r))
				(P2_d (datamemorywriting_pipeline P2 P1_d))
			)

;----------------P to I flush 3------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P3 (pipeline P2 P2_d P2_r flush))
			)
		(let
			(
				(P3_r (regfilewriting_pipeline P3 P2_r))
				(P3_d (datamemorywriting_pipeline P3 P2_d))
			)
;----------------P to I flush 4------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P4 (pipeline P3 P3_d P3_r flush))
			)
		(let
			(
				(P4_r (regfilewriting_pipeline P4 P3_r))
				(P4_d (datamemorywriting_pipeline P4 P3_d))
			)
;----------------P to I flush 5------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P5 (pipeline P4 P4_d P4_r flush))
			)
		(let
			(
				(P5_r (regfilewriting_pipeline P5 P4_r))
				(P5_d (datamemorywriting_pipeline P5 P4_d))
			)
;----------------P to I flush 6------------------------------------------------------------------------------------------------------------------
		(let
			(
				(P6 (pipeline P5 P5_d P5_r flush))
			)
		(let
			(
				(P6_r (regfilewriting_pipeline P6 P5_r))
				(P6_d (datamemorywriting_pipeline P6 P5_d))
			)

;----------------P to I flush 7------------------------------------------------------------------------------------------------------------------
		(let
			(
				(I (pipeline P6 P6_d P6_r flush))
			)
		(let
			(
				(I_r (regfilewriting_pipeline I P6_r))
				(I_d (datamemorywriting_pipeline I P6_d))
			)
			
;----------------------------------------------------------------------------------------------------------------------------
;------------------property------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
		(let
			(	
				(Qf_pccounter ((_ extract 620 589) Qf))
				(I_pccounter ((_ extract 620 589) I))
			)	
		(=>
			(and (= flush (_ bv1 1)) (= noflush (_ bv0 1)) (= bit_0 (_ bv0 1)) (= bit_1 (_ bv1 1)))
			
			(and (= Qf_d I_d) 
				 (= I_pccounter Qf_pccounter)
				 (= Qf_r I_r))		
			)
		)))))))))))))))))))))))))))))))))
	)
)

(check-sat)
(get-model)
